#region Using declarations
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;
using System.Windows.Media;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Gui;
using NinjaTrader.Gui.Chart;
using NinjaTrader.Gui.SuperDom;
using NinjaTrader.Gui.Tools;
using NinjaTrader.Data;
using NinjaTrader.NinjaScript;
using NinjaTrader.Core.FloatingPoint;

#endregion



#region NinjaScript generated code. Neither change nor remove.

namespace NinjaTrader.NinjaScript.Indicators
{
	public partial class Indicator : NinjaTrader.Gui.NinjaScript.IndicatorRenderBase
	{
		
		private trader_algoritmico.Price.BilliardBands[] cacheBilliardBands;
		private trader_algoritmico.Price.DynamicSupportResistance[] cacheDynamicSupportResistance;
		private trader_algoritmico.Price.Esperanzag[] cacheEsperanzag;
		private trader_algoritmico.Price.LiquidityLevels[] cacheLiquidityLevels;
		private trader_algoritmico.Price.MaxFO[] cacheMaxFO;
		private trader_algoritmico.Price.PowerTrend[] cachePowerTrend;
		private trader_algoritmico.Price.PriceActionTrail[] cachePriceActionTrail;
		private trader_algoritmico.Price.TimePivots[] cacheTimePivots;
		private trader_algoritmico.Price.TrendFilter[] cacheTrendFilter;
		private trader_algoritmico.Price.WhereTo[] cacheWhereTo;
		private trader_algoritmico.Utilities.DrawAlert[] cacheDrawAlert;
		private trader_algoritmico.Utilities.Info[] cacheInfo;
		private trader_algoritmico.Utilities.JoiaRenkoPrice[] cacheJoiaRenkoPrice;
		private trader_algoritmico.Utilities.OpeningMarker[] cacheOpeningMarker;
		private trader_algoritmico.Utilities.TickElectrifier[] cacheTickElectrifier;
		private trader_algoritmico.Utilities.TradeManager[] cacheTradeManager;
		private trader_algoritmico.Volume.ATA[] cacheATA;
		private trader_algoritmico.Volume.Bands[] cacheBands;
		private trader_algoritmico.Volume.CandlePOC[] cacheCandlePOC;
		private trader_algoritmico.Volume.DeltaDivergence[] cacheDeltaDivergence;
		private trader_algoritmico.Volume.HeatMap_level2[] cacheHeatMap_level2;
		private trader_algoritmico.Volume.JonReversionPoint[] cacheJonReversionPoint;
		private trader_algoritmico.Volume.OrderFlow[] cacheOrderFlow;
		private trader_algoritmico.Volume.PSC[] cachePSC;
		private trader_algoritmico.Volume.TapeReconstructor[] cacheTapeReconstructor;
		private trader_algoritmico.Volume.TradeDetection[] cacheTradeDetection;
		private trader_algoritmico.Volume.VolumePro[] cacheVolumePro;
		private trader_algoritmico.Volume.VolumeProfileChart[] cacheVolumeProfileChart;
		private trader_algoritmico.Volume.VolumeProfilePro[] cacheVolumeProfilePro;
		private trader_algoritmico.Volume.VPOC[] cacheVPOC;
		private trader_algoritmico.Volume.VWAP[] cacheVWAP;

		
		public trader_algoritmico.Price.BilliardBands BilliardBands(int numeroBandas)
		{
			return BilliardBands(Input, numeroBandas);
		}

		public trader_algoritmico.Price.DynamicSupportResistance DynamicSupportResistance()
		{
			return DynamicSupportResistance(Input);
		}

		public trader_algoritmico.Price.Esperanzag Esperanzag(string indicatorName, bool showIndicatorName, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Price.SwingStyle swingType, double swingSize, int dtbStrength, bool useCloseValues, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Price.SwingLengthStyle swingLengthType, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Price.SwingDurationStyle swingDurationType, bool showSwingPrice, bool showSwingLabel, bool showSwingPercent, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Price.SwingTimeStyle swingTimeType, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Price.SwingVolumeStyle swingVolumeType, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Price.VisualizationStyle visualizationType, NinjaTrader.Gui.Tools.SimpleFont textFont, int textOffsetLength, int textOffsetVolume, int textOffsetPrice, int textOffsetLabel, int textOffsetTime, int textOffsetPercent, DashStyleHelper linesStyle, int linesWidth, bool ignoreInsideBars, bool useBreakouts)
		{
			return Esperanzag(Input, indicatorName, showIndicatorName, swingType, swingSize, dtbStrength, useCloseValues, swingLengthType, swingDurationType, showSwingPrice, showSwingLabel, showSwingPercent, swingTimeType, swingVolumeType, visualizationType, textFont, textOffsetLength, textOffsetVolume, textOffsetPrice, textOffsetLabel, textOffsetTime, textOffsetPercent, linesStyle, linesWidth, ignoreInsideBars, useBreakouts);
		}

		public trader_algoritmico.Price.LiquidityLevels LiquidityLevels(bool activateLL, bool deleteLine, bool activateFVG, bool useFVGDataSeries, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Price.FVGPeriodTypes fVGBarsPeriodType, int fVGSeriesPeriod, int maxBars, bool useATR, int aTRPeriod, double impulseFactor, double minimumFVGSize, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Price.FVGFillType fillType, bool hideFilledGaps, bool displayCE, int activeAreaOpacity, int filledAreaOpacity, bool drawLabel)
		{
			return LiquidityLevels(Input, activateLL, deleteLine, activateFVG, useFVGDataSeries, fVGBarsPeriodType, fVGSeriesPeriod, maxBars, useATR, aTRPeriod, impulseFactor, minimumFVGSize, fillType, hideFilledGaps, displayCE, activeAreaOpacity, filledAreaOpacity, drawLabel);
		}

		public trader_algoritmico.Price.MaxFO MaxFO(DateTime startTime, DateTime endTime)
		{
			return MaxFO(Input, startTime, endTime);
		}

		public trader_algoritmico.Price.PowerTrend PowerTrend()
		{
			return PowerTrend(Input);
		}

		public trader_algoritmico.Price.PriceActionTrail PriceActionTrail()
		{
			return PriceActionTrail(Input);
		}

		public trader_algoritmico.Price.TimePivots TimePivots(bool showWeeklyPivots, bool showMonthlyPivot, bool showOpen, bool showPivot)
		{
			return TimePivots(Input, showWeeklyPivots, showMonthlyPivot, showOpen, showPivot);
		}

		public trader_algoritmico.Price.TrendFilter TrendFilter(int eMA1, int eMA2, int eMA3, bool filtro_vpoc)
		{
			return TrendFilter(Input, eMA1, eMA2, eMA3, filtro_vpoc);
		}

		public trader_algoritmico.Price.WhereTo WhereTo(string whereToXX1, string whereToXX2, string whereToXX3)
		{
			return WhereTo(Input, whereToXX1, whereToXX2, whereToXX3);
		}

		public trader_algoritmico.Utilities.DrawAlert DrawAlert()
		{
			return DrawAlert(Input);
		}

		public trader_algoritmico.Utilities.Info Info(int letraSize, Brush letraColor, bool mostrarSpread, bool mostrarNombreCuentaActual, bool mostrarTR, bool mostrarTickSize, bool showPnl, Brush defaultTextColor, Brush inProfitColor, Brush inLossColor, Brush activeOrderColor, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Utilities.Info.textPosition basisTextLocation, bool showNetPriceChange, Cbi.PerformanceUnit unit, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Utilities.Info.textPosition location)
		{
			return Info(Input, letraSize, letraColor, mostrarSpread, mostrarNombreCuentaActual, mostrarTR, mostrarTickSize, showPnl, defaultTextColor, inProfitColor, inLossColor, activeOrderColor, basisTextLocation, showNetPriceChange, unit, location);
		}

		public trader_algoritmico.Utilities.JoiaRenkoPrice JoiaRenkoPrice()
		{
			return JoiaRenkoPrice(Input);
		}

		public trader_algoritmico.Utilities.OpeningMarker OpeningMarker(DateTime lineTime, Brush lineColor, DashStyleHelper lineDashStyle, int lineThickness, int barToLineOffsetInTicks)
		{
			return OpeningMarker(Input, lineTime, lineColor, lineDashStyle, lineThickness, barToLineOffsetInTicks);
		}

		public trader_algoritmico.Utilities.TickElectrifier TickElectrifier(int frecuenciaActualizacion)
		{
			return TickElectrifier(Input, frecuenciaActualizacion);
		}

		public trader_algoritmico.Utilities.TradeManager TradeManager(string selectedAccountName, double _maxDailyProfit, double _maxDailyLoss, int contracts_quantity, bool _usePercentageInsteadOfContracts, double _percentageOfBalanceForTrade, bool _useAtm, bool _tradingDrawnLevel, int usePredSL, int usePredTP, bool _set_BE, int _be_ticks_offset, bool _set_Trailing_Stop, int _tr_start, int _tr_offset, bool _setChangeTSafterProfit, double _changeTSafterProfit, bool _allowEnterOnlyIfVPOCinFavor, bool _allowEnterOnlyIfVWAPinFavor, bool _allowEnterOnlyIfEMA20inFavor, bool _allowEnterOnlyIfBtinFavor, bool _setExitOnBigTrade, bool _setExitOnVPOC, bool _setExitOnVSC, bool _setExitOnClimax)
		{
			return TradeManager(Input, selectedAccountName, _maxDailyProfit, _maxDailyLoss, contracts_quantity, _usePercentageInsteadOfContracts, _percentageOfBalanceForTrade, _useAtm, _tradingDrawnLevel, usePredSL, usePredTP, _set_BE, _be_ticks_offset, _set_Trailing_Stop, _tr_start, _tr_offset, _setChangeTSafterProfit, _changeTSafterProfit, _allowEnterOnlyIfVPOCinFavor, _allowEnterOnlyIfVWAPinFavor, _allowEnterOnlyIfEMA20inFavor, _allowEnterOnlyIfBtinFavor, _setExitOnBigTrade, _setExitOnVPOC, _setExitOnVSC, _setExitOnClimax);
		}

		public trader_algoritmico.Volume.ATA ATA(int filter_percentile, Brush colorbt, Brush colorbighand, Brush colorclimax)
		{
			return ATA(Input, filter_percentile, colorbt, colorbighand, colorclimax);
		}

		public trader_algoritmico.Volume.Bands Bands(int apilao, int filtro, double filtro2_ratio, int barrasEnFuturo, bool clustersDe1tick)
		{
			return Bands(Input, apilao, filtro, filtro2_ratio, barrasEnFuturo, clustersDe1tick);
		}

		public trader_algoritmico.Volume.CandlePOC CandlePOC()
		{
			return CandlePOC(Input);
		}

		public trader_algoritmico.Volume.DeltaDivergence DeltaDivergence(Brush barColorDown, Brush barColorUp, Brush shadowColor, int shadowWidth, bool _setAlert, int minSize)
		{
			return DeltaDivergence(Input, barColorDown, barColorUp, shadowColor, shadowWidth, _setAlert, minSize);
		}

		public trader_algoritmico.Volume.HeatMap_level2 HeatMap_level2(string _sessionSaveFilePath, bool _saveSession, _HeatMapEnums.LadderRange _ladderRange, _HeatMapEnums.MarketOrdersCalculation _marketOrdersCalculation, _HeatMapEnums.MarketBarsCalculation _marketBarsCalculation, long _aggresiveMarketOrdersFilter, long _filterBigPendingOrders, float _filterPendingOrdersPer, _HeatMapEnums.MarketCummulativeCalculation _marketCummulativeCalculation)
		{
			return HeatMap_level2(Input, _sessionSaveFilePath, _saveSession, _ladderRange, _marketOrdersCalculation, _marketBarsCalculation, _aggresiveMarketOrdersFilter, _filterBigPendingOrders, _filterPendingOrdersPer, _marketCummulativeCalculation);
		}

		public trader_algoritmico.Volume.JonReversionPoint JonReversionPoint(Brush barColorDown, Brush barColorUp, Brush shadowColor, int shadowWidth, bool cumulativeDelta, int minSize, bool showDivs)
		{
			return JonReversionPoint(Input, barColorDown, barColorUp, shadowColor, shadowWidth, cumulativeDelta, minSize, showDivs);
		}

		public trader_algoritmico.Volume.OrderFlow OrderFlow(_OrderFlowEnums.Calculation _oFmethod, _OrderFlowEnums.Representation _oFtakeTextFrom, _OrderFlowEnums.Style _oFStyle, bool _bands, bool _exausthion)
		{
			return OrderFlow(Input, _oFmethod, _oFtakeTextFrom, _oFStyle, _bands, _exausthion);
		}

		public trader_algoritmico.Volume.PSC PSC(bool psc, bool vel_igual, double mecha, int donde_vol, bool _volumeInsideBody)
		{
			return PSC(Input, psc, vel_igual, mecha, donde_vol, _volumeInsideBody);
		}

		public trader_algoritmico.Volume.TapeReconstructor TapeReconstructor(bool aggregateTrades, Brush colorForCircle)
		{
			return TapeReconstructor(Input, aggregateTrades, colorForCircle);
		}

		public trader_algoritmico.Volume.TradeDetection TradeDetection(__VolumeFilterProperties.Formula _formula, long _minVolumeFilter, bool _fillGeometry)
		{
			return TradeDetection(Input, _formula, _minVolumeFilter, _fillGeometry);
		}

		public trader_algoritmico.Volume.VolumePro VolumePro(_MarketAnalyzerEnums.Calculation _marketAnalyzerCalculation, int _period)
		{
			return VolumePro(Input, _marketAnalyzerCalculation, _period);
		}

		public trader_algoritmico.Volume.VolumeProfileChart VolumeProfileChart()
		{
			return VolumeProfileChart(Input);
		}

		public trader_algoritmico.Volume.VolumeProfilePro VolumeProfilePro(NinjaTrader.NinjaScript.Indicators.trader_algoritmico.traderAlgoritmicoAddon.VolumeAnalysis.PeriodMode _periodMode, int _period, bool _showPOC, bool _showPOI, bool _realtimeHeuristic, float _pOCOpacity, float _pOIOpacity, float _selectionOpacity, float _eraseOpacity, float _textOpacity, SimpleFont _textFont, bool _showText, float _minFontWidth, float _minFontHeight)
		{
			return VolumeProfilePro(Input, _periodMode, _period, _showPOC, _showPOI, _realtimeHeuristic, _pOCOpacity, _pOIOpacity, _selectionOpacity, _eraseOpacity, _textOpacity, _textFont, _showText, _minFontWidth, _minFontHeight);
		}

		public trader_algoritmico.Volume.VPOC VPOC(DateTime horaInicio)
		{
			return VPOC(Input, horaInicio);
		}

		public trader_algoritmico.Volume.VWAP VWAP(DateTime horaInicio)
		{
			return VWAP(Input, horaInicio);
		}


		
		public trader_algoritmico.Price.BilliardBands BilliardBands(ISeries<double> input, int numeroBandas)
		{
			if (cacheBilliardBands != null)
				for (int idx = 0; idx < cacheBilliardBands.Length; idx++)
					if (cacheBilliardBands[idx].NumeroBandas == numeroBandas && cacheBilliardBands[idx].EqualsInput(input))
						return cacheBilliardBands[idx];
			return CacheIndicator<trader_algoritmico.Price.BilliardBands>(new trader_algoritmico.Price.BilliardBands(){ NumeroBandas = numeroBandas }, input, ref cacheBilliardBands);
		}

		public trader_algoritmico.Price.DynamicSupportResistance DynamicSupportResistance(ISeries<double> input)
		{
			if (cacheDynamicSupportResistance != null)
				for (int idx = 0; idx < cacheDynamicSupportResistance.Length; idx++)
					if ( cacheDynamicSupportResistance[idx].EqualsInput(input))
						return cacheDynamicSupportResistance[idx];
			return CacheIndicator<trader_algoritmico.Price.DynamicSupportResistance>(new trader_algoritmico.Price.DynamicSupportResistance(), input, ref cacheDynamicSupportResistance);
		}

		public trader_algoritmico.Price.Esperanzag Esperanzag(ISeries<double> input, string indicatorName, bool showIndicatorName, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Price.SwingStyle swingType, double swingSize, int dtbStrength, bool useCloseValues, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Price.SwingLengthStyle swingLengthType, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Price.SwingDurationStyle swingDurationType, bool showSwingPrice, bool showSwingLabel, bool showSwingPercent, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Price.SwingTimeStyle swingTimeType, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Price.SwingVolumeStyle swingVolumeType, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Price.VisualizationStyle visualizationType, NinjaTrader.Gui.Tools.SimpleFont textFont, int textOffsetLength, int textOffsetVolume, int textOffsetPrice, int textOffsetLabel, int textOffsetTime, int textOffsetPercent, DashStyleHelper linesStyle, int linesWidth, bool ignoreInsideBars, bool useBreakouts)
		{
			if (cacheEsperanzag != null)
				for (int idx = 0; idx < cacheEsperanzag.Length; idx++)
					if (cacheEsperanzag[idx].IndicatorName == indicatorName && cacheEsperanzag[idx].ShowIndicatorName == showIndicatorName && cacheEsperanzag[idx].SwingType == swingType && cacheEsperanzag[idx].SwingSize == swingSize && cacheEsperanzag[idx].DtbStrength == dtbStrength && cacheEsperanzag[idx].UseCloseValues == useCloseValues && cacheEsperanzag[idx].SwingLengthType == swingLengthType && cacheEsperanzag[idx].SwingDurationType == swingDurationType && cacheEsperanzag[idx].ShowSwingPrice == showSwingPrice && cacheEsperanzag[idx].ShowSwingLabel == showSwingLabel && cacheEsperanzag[idx].ShowSwingPercent == showSwingPercent && cacheEsperanzag[idx].SwingTimeType == swingTimeType && cacheEsperanzag[idx].SwingVolumeType == swingVolumeType && cacheEsperanzag[idx].VisualizationType == visualizationType && cacheEsperanzag[idx].TextFont == textFont && cacheEsperanzag[idx].TextOffsetLength == textOffsetLength && cacheEsperanzag[idx].TextOffsetVolume == textOffsetVolume && cacheEsperanzag[idx].TextOffsetPrice == textOffsetPrice && cacheEsperanzag[idx].TextOffsetLabel == textOffsetLabel && cacheEsperanzag[idx].TextOffsetTime == textOffsetTime && cacheEsperanzag[idx].TextOffsetPercent == textOffsetPercent && cacheEsperanzag[idx].LinesStyle == linesStyle && cacheEsperanzag[idx].LinesWidth == linesWidth && cacheEsperanzag[idx].IgnoreInsideBars == ignoreInsideBars && cacheEsperanzag[idx].UseBreakouts == useBreakouts && cacheEsperanzag[idx].EqualsInput(input))
						return cacheEsperanzag[idx];
			return CacheIndicator<trader_algoritmico.Price.Esperanzag>(new trader_algoritmico.Price.Esperanzag(){ IndicatorName = indicatorName, ShowIndicatorName = showIndicatorName, SwingType = swingType, SwingSize = swingSize, DtbStrength = dtbStrength, UseCloseValues = useCloseValues, SwingLengthType = swingLengthType, SwingDurationType = swingDurationType, ShowSwingPrice = showSwingPrice, ShowSwingLabel = showSwingLabel, ShowSwingPercent = showSwingPercent, SwingTimeType = swingTimeType, SwingVolumeType = swingVolumeType, VisualizationType = visualizationType, TextFont = textFont, TextOffsetLength = textOffsetLength, TextOffsetVolume = textOffsetVolume, TextOffsetPrice = textOffsetPrice, TextOffsetLabel = textOffsetLabel, TextOffsetTime = textOffsetTime, TextOffsetPercent = textOffsetPercent, LinesStyle = linesStyle, LinesWidth = linesWidth, IgnoreInsideBars = ignoreInsideBars, UseBreakouts = useBreakouts }, input, ref cacheEsperanzag);
		}

		public trader_algoritmico.Price.LiquidityLevels LiquidityLevels(ISeries<double> input, bool activateLL, bool deleteLine, bool activateFVG, bool useFVGDataSeries, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Price.FVGPeriodTypes fVGBarsPeriodType, int fVGSeriesPeriod, int maxBars, bool useATR, int aTRPeriod, double impulseFactor, double minimumFVGSize, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Price.FVGFillType fillType, bool hideFilledGaps, bool displayCE, int activeAreaOpacity, int filledAreaOpacity, bool drawLabel)
		{
			if (cacheLiquidityLevels != null)
				for (int idx = 0; idx < cacheLiquidityLevels.Length; idx++)
					if (cacheLiquidityLevels[idx].activateLL == activateLL && cacheLiquidityLevels[idx].deleteLine == deleteLine && cacheLiquidityLevels[idx].activateFVG == activateFVG && cacheLiquidityLevels[idx].UseFVGDataSeries == useFVGDataSeries && cacheLiquidityLevels[idx].FVGBarsPeriodType == fVGBarsPeriodType && cacheLiquidityLevels[idx].FVGSeriesPeriod == fVGSeriesPeriod && cacheLiquidityLevels[idx].MaxBars == maxBars && cacheLiquidityLevels[idx].UseATR == useATR && cacheLiquidityLevels[idx].ATRPeriod == aTRPeriod && cacheLiquidityLevels[idx].ImpulseFactor == impulseFactor && cacheLiquidityLevels[idx].MinimumFVGSize == minimumFVGSize && cacheLiquidityLevels[idx].FillType == fillType && cacheLiquidityLevels[idx].HideFilledGaps == hideFilledGaps && cacheLiquidityLevels[idx].DisplayCE == displayCE && cacheLiquidityLevels[idx].ActiveAreaOpacity == activeAreaOpacity && cacheLiquidityLevels[idx].FilledAreaOpacity == filledAreaOpacity && cacheLiquidityLevels[idx].DrawLabel == drawLabel && cacheLiquidityLevels[idx].EqualsInput(input))
						return cacheLiquidityLevels[idx];
			return CacheIndicator<trader_algoritmico.Price.LiquidityLevels>(new trader_algoritmico.Price.LiquidityLevels(){ activateLL = activateLL, deleteLine = deleteLine, activateFVG = activateFVG, UseFVGDataSeries = useFVGDataSeries, FVGBarsPeriodType = fVGBarsPeriodType, FVGSeriesPeriod = fVGSeriesPeriod, MaxBars = maxBars, UseATR = useATR, ATRPeriod = aTRPeriod, ImpulseFactor = impulseFactor, MinimumFVGSize = minimumFVGSize, FillType = fillType, HideFilledGaps = hideFilledGaps, DisplayCE = displayCE, ActiveAreaOpacity = activeAreaOpacity, FilledAreaOpacity = filledAreaOpacity, DrawLabel = drawLabel }, input, ref cacheLiquidityLevels);
		}

		public trader_algoritmico.Price.MaxFO MaxFO(ISeries<double> input, DateTime startTime, DateTime endTime)
		{
			if (cacheMaxFO != null)
				for (int idx = 0; idx < cacheMaxFO.Length; idx++)
					if (cacheMaxFO[idx].StartTime == startTime && cacheMaxFO[idx].EndTime == endTime && cacheMaxFO[idx].EqualsInput(input))
						return cacheMaxFO[idx];
			return CacheIndicator<trader_algoritmico.Price.MaxFO>(new trader_algoritmico.Price.MaxFO(){ StartTime = startTime, EndTime = endTime }, input, ref cacheMaxFO);
		}

		public trader_algoritmico.Price.PowerTrend PowerTrend(ISeries<double> input)
		{
			if (cachePowerTrend != null)
				for (int idx = 0; idx < cachePowerTrend.Length; idx++)
					if ( cachePowerTrend[idx].EqualsInput(input))
						return cachePowerTrend[idx];
			return CacheIndicator<trader_algoritmico.Price.PowerTrend>(new trader_algoritmico.Price.PowerTrend(), input, ref cachePowerTrend);
		}

		public trader_algoritmico.Price.PriceActionTrail PriceActionTrail(ISeries<double> input)
		{
			if (cachePriceActionTrail != null)
				for (int idx = 0; idx < cachePriceActionTrail.Length; idx++)
					if ( cachePriceActionTrail[idx].EqualsInput(input))
						return cachePriceActionTrail[idx];
			return CacheIndicator<trader_algoritmico.Price.PriceActionTrail>(new trader_algoritmico.Price.PriceActionTrail(), input, ref cachePriceActionTrail);
		}

		public trader_algoritmico.Price.TimePivots TimePivots(ISeries<double> input, bool showWeeklyPivots, bool showMonthlyPivot, bool showOpen, bool showPivot)
		{
			if (cacheTimePivots != null)
				for (int idx = 0; idx < cacheTimePivots.Length; idx++)
					if (cacheTimePivots[idx].ShowWeeklyPivots == showWeeklyPivots && cacheTimePivots[idx].ShowMonthlyPivot == showMonthlyPivot && cacheTimePivots[idx].ShowOpen == showOpen && cacheTimePivots[idx].ShowPivot == showPivot && cacheTimePivots[idx].EqualsInput(input))
						return cacheTimePivots[idx];
			return CacheIndicator<trader_algoritmico.Price.TimePivots>(new trader_algoritmico.Price.TimePivots(){ ShowWeeklyPivots = showWeeklyPivots, ShowMonthlyPivot = showMonthlyPivot, ShowOpen = showOpen, ShowPivot = showPivot }, input, ref cacheTimePivots);
		}

		public trader_algoritmico.Price.TrendFilter TrendFilter(ISeries<double> input, int eMA1, int eMA2, int eMA3, bool filtro_vpoc)
		{
			if (cacheTrendFilter != null)
				for (int idx = 0; idx < cacheTrendFilter.Length; idx++)
					if (cacheTrendFilter[idx].EMA1 == eMA1 && cacheTrendFilter[idx].EMA2 == eMA2 && cacheTrendFilter[idx].EMA3 == eMA3 && cacheTrendFilter[idx].filtro_vpoc == filtro_vpoc && cacheTrendFilter[idx].EqualsInput(input))
						return cacheTrendFilter[idx];
			return CacheIndicator<trader_algoritmico.Price.TrendFilter>(new trader_algoritmico.Price.TrendFilter(){ EMA1 = eMA1, EMA2 = eMA2, EMA3 = eMA3, filtro_vpoc = filtro_vpoc }, input, ref cacheTrendFilter);
		}

		public trader_algoritmico.Price.WhereTo WhereTo(ISeries<double> input, string whereToXX1, string whereToXX2, string whereToXX3)
		{
			if (cacheWhereTo != null)
				for (int idx = 0; idx < cacheWhereTo.Length; idx++)
					if (cacheWhereTo[idx].WhereToXX1 == whereToXX1 && cacheWhereTo[idx].WhereToXX2 == whereToXX2 && cacheWhereTo[idx].WhereToXX3 == whereToXX3 && cacheWhereTo[idx].EqualsInput(input))
						return cacheWhereTo[idx];
			return CacheIndicator<trader_algoritmico.Price.WhereTo>(new trader_algoritmico.Price.WhereTo(){ WhereToXX1 = whereToXX1, WhereToXX2 = whereToXX2, WhereToXX3 = whereToXX3 }, input, ref cacheWhereTo);
		}

		public trader_algoritmico.Utilities.DrawAlert DrawAlert(ISeries<double> input)
		{
			if (cacheDrawAlert != null)
				for (int idx = 0; idx < cacheDrawAlert.Length; idx++)
					if ( cacheDrawAlert[idx].EqualsInput(input))
						return cacheDrawAlert[idx];
			return CacheIndicator<trader_algoritmico.Utilities.DrawAlert>(new trader_algoritmico.Utilities.DrawAlert(), input, ref cacheDrawAlert);
		}

		public trader_algoritmico.Utilities.Info Info(ISeries<double> input, int letraSize, Brush letraColor, bool mostrarSpread, bool mostrarNombreCuentaActual, bool mostrarTR, bool mostrarTickSize, bool showPnl, Brush defaultTextColor, Brush inProfitColor, Brush inLossColor, Brush activeOrderColor, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Utilities.Info.textPosition basisTextLocation, bool showNetPriceChange, Cbi.PerformanceUnit unit, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Utilities.Info.textPosition location)
		{
			if (cacheInfo != null)
				for (int idx = 0; idx < cacheInfo.Length; idx++)
					if (cacheInfo[idx].LetraSize == letraSize && cacheInfo[idx].LetraColor == letraColor && cacheInfo[idx].MostrarSpread == mostrarSpread && cacheInfo[idx].MostrarNombreCuentaActual == mostrarNombreCuentaActual && cacheInfo[idx].MostrarTR == mostrarTR && cacheInfo[idx].MostrarTickSize == mostrarTickSize && cacheInfo[idx].ShowPnl == showPnl && cacheInfo[idx].DefaultTextColor == defaultTextColor && cacheInfo[idx].InProfitColor == inProfitColor && cacheInfo[idx].InLossColor == inLossColor && cacheInfo[idx].ActiveOrderColor == activeOrderColor && cacheInfo[idx].BasisTextLocation == basisTextLocation && cacheInfo[idx].showNetPriceChange == showNetPriceChange && cacheInfo[idx].Unit == unit && cacheInfo[idx].Location == location && cacheInfo[idx].EqualsInput(input))
						return cacheInfo[idx];
			return CacheIndicator<trader_algoritmico.Utilities.Info>(new trader_algoritmico.Utilities.Info(){ LetraSize = letraSize, LetraColor = letraColor, MostrarSpread = mostrarSpread, MostrarNombreCuentaActual = mostrarNombreCuentaActual, MostrarTR = mostrarTR, MostrarTickSize = mostrarTickSize, ShowPnl = showPnl, DefaultTextColor = defaultTextColor, InProfitColor = inProfitColor, InLossColor = inLossColor, ActiveOrderColor = activeOrderColor, BasisTextLocation = basisTextLocation, showNetPriceChange = showNetPriceChange, Unit = unit, Location = location }, input, ref cacheInfo);
		}

		public trader_algoritmico.Utilities.JoiaRenkoPrice JoiaRenkoPrice(ISeries<double> input)
		{
			if (cacheJoiaRenkoPrice != null)
				for (int idx = 0; idx < cacheJoiaRenkoPrice.Length; idx++)
					if ( cacheJoiaRenkoPrice[idx].EqualsInput(input))
						return cacheJoiaRenkoPrice[idx];
			return CacheIndicator<trader_algoritmico.Utilities.JoiaRenkoPrice>(new trader_algoritmico.Utilities.JoiaRenkoPrice(), input, ref cacheJoiaRenkoPrice);
		}

		public trader_algoritmico.Utilities.OpeningMarker OpeningMarker(ISeries<double> input, DateTime lineTime, Brush lineColor, DashStyleHelper lineDashStyle, int lineThickness, int barToLineOffsetInTicks)
		{
			if (cacheOpeningMarker != null)
				for (int idx = 0; idx < cacheOpeningMarker.Length; idx++)
					if (cacheOpeningMarker[idx].LineTime == lineTime && cacheOpeningMarker[idx].LineColor == lineColor && cacheOpeningMarker[idx].LineDashStyle == lineDashStyle && cacheOpeningMarker[idx].LineThickness == lineThickness && cacheOpeningMarker[idx].BarToLineOffsetInTicks == barToLineOffsetInTicks && cacheOpeningMarker[idx].EqualsInput(input))
						return cacheOpeningMarker[idx];
			return CacheIndicator<trader_algoritmico.Utilities.OpeningMarker>(new trader_algoritmico.Utilities.OpeningMarker(){ LineTime = lineTime, LineColor = lineColor, LineDashStyle = lineDashStyle, LineThickness = lineThickness, BarToLineOffsetInTicks = barToLineOffsetInTicks }, input, ref cacheOpeningMarker);
		}

		public trader_algoritmico.Utilities.TickElectrifier TickElectrifier(ISeries<double> input, int frecuenciaActualizacion)
		{
			if (cacheTickElectrifier != null)
				for (int idx = 0; idx < cacheTickElectrifier.Length; idx++)
					if (cacheTickElectrifier[idx].FrecuenciaActualizacion == frecuenciaActualizacion && cacheTickElectrifier[idx].EqualsInput(input))
						return cacheTickElectrifier[idx];
			return CacheIndicator<trader_algoritmico.Utilities.TickElectrifier>(new trader_algoritmico.Utilities.TickElectrifier(){ FrecuenciaActualizacion = frecuenciaActualizacion }, input, ref cacheTickElectrifier);
		}

		public trader_algoritmico.Utilities.TradeManager TradeManager(ISeries<double> input, string selectedAccountName, double _maxDailyProfit, double _maxDailyLoss, int contracts_quantity, bool _usePercentageInsteadOfContracts, double _percentageOfBalanceForTrade, bool _useAtm, bool _tradingDrawnLevel, int usePredSL, int usePredTP, bool _set_BE, int _be_ticks_offset, bool _set_Trailing_Stop, int _tr_start, int _tr_offset, bool _setChangeTSafterProfit, double _changeTSafterProfit, bool _allowEnterOnlyIfVPOCinFavor, bool _allowEnterOnlyIfVWAPinFavor, bool _allowEnterOnlyIfEMA20inFavor, bool _allowEnterOnlyIfBtinFavor, bool _setExitOnBigTrade, bool _setExitOnVPOC, bool _setExitOnVSC, bool _setExitOnClimax)
		{
			if (cacheTradeManager != null)
				for (int idx = 0; idx < cacheTradeManager.Length; idx++)
					if (cacheTradeManager[idx].selectedAccountName == selectedAccountName && cacheTradeManager[idx]._maxDailyProfit == _maxDailyProfit && cacheTradeManager[idx]._maxDailyLoss == _maxDailyLoss && cacheTradeManager[idx].contracts_quantity == contracts_quantity && cacheTradeManager[idx]._usePercentageInsteadOfContracts == _usePercentageInsteadOfContracts && cacheTradeManager[idx]._PercentageOfBalanceForTrade == _percentageOfBalanceForTrade && cacheTradeManager[idx]._useAtm == _useAtm && cacheTradeManager[idx]._tradingDrawnLevel == _tradingDrawnLevel && cacheTradeManager[idx].usePredSL == usePredSL && cacheTradeManager[idx].usePredTP == usePredTP && cacheTradeManager[idx]._set_BE == _set_BE && cacheTradeManager[idx]._be_ticks_offset == _be_ticks_offset && cacheTradeManager[idx]._set_Trailing_Stop == _set_Trailing_Stop && cacheTradeManager[idx]._tr_start == _tr_start && cacheTradeManager[idx]._tr_offset == _tr_offset && cacheTradeManager[idx]._setChangeTSafterProfit == _setChangeTSafterProfit && cacheTradeManager[idx]._changeTSafterProfit == _changeTSafterProfit && cacheTradeManager[idx]._AllowEnterOnlyIfVPOCinFavor == _allowEnterOnlyIfVPOCinFavor && cacheTradeManager[idx]._AllowEnterOnlyIfVWAPinFavor == _allowEnterOnlyIfVWAPinFavor && cacheTradeManager[idx]._AllowEnterOnlyIfEMA20inFavor == _allowEnterOnlyIfEMA20inFavor && cacheTradeManager[idx]._AllowEnterOnlyIfBtinFavor == _allowEnterOnlyIfBtinFavor && cacheTradeManager[idx]._setExitOnBigTrade == _setExitOnBigTrade && cacheTradeManager[idx]._setExitOnVPOC == _setExitOnVPOC && cacheTradeManager[idx]._setExitOnVSC == _setExitOnVSC && cacheTradeManager[idx]._setExitOnClimax == _setExitOnClimax && cacheTradeManager[idx].EqualsInput(input))
						return cacheTradeManager[idx];
			return CacheIndicator<trader_algoritmico.Utilities.TradeManager>(new trader_algoritmico.Utilities.TradeManager(){ selectedAccountName = selectedAccountName, _maxDailyProfit = _maxDailyProfit, _maxDailyLoss = _maxDailyLoss, contracts_quantity = contracts_quantity, _usePercentageInsteadOfContracts = _usePercentageInsteadOfContracts, _PercentageOfBalanceForTrade = _percentageOfBalanceForTrade, _useAtm = _useAtm, _tradingDrawnLevel = _tradingDrawnLevel, usePredSL = usePredSL, usePredTP = usePredTP, _set_BE = _set_BE, _be_ticks_offset = _be_ticks_offset, _set_Trailing_Stop = _set_Trailing_Stop, _tr_start = _tr_start, _tr_offset = _tr_offset, _setChangeTSafterProfit = _setChangeTSafterProfit, _changeTSafterProfit = _changeTSafterProfit, _AllowEnterOnlyIfVPOCinFavor = _allowEnterOnlyIfVPOCinFavor, _AllowEnterOnlyIfVWAPinFavor = _allowEnterOnlyIfVWAPinFavor, _AllowEnterOnlyIfEMA20inFavor = _allowEnterOnlyIfEMA20inFavor, _AllowEnterOnlyIfBtinFavor = _allowEnterOnlyIfBtinFavor, _setExitOnBigTrade = _setExitOnBigTrade, _setExitOnVPOC = _setExitOnVPOC, _setExitOnVSC = _setExitOnVSC, _setExitOnClimax = _setExitOnClimax }, input, ref cacheTradeManager);
		}

		public trader_algoritmico.Volume.ATA ATA(ISeries<double> input, int filter_percentile, Brush colorbt, Brush colorbighand, Brush colorclimax)
		{
			if (cacheATA != null)
				for (int idx = 0; idx < cacheATA.Length; idx++)
					if (cacheATA[idx].filter_percentile == filter_percentile && cacheATA[idx].Colorbt == colorbt && cacheATA[idx].Colorbighand == colorbighand && cacheATA[idx].Colorclimax == colorclimax && cacheATA[idx].EqualsInput(input))
						return cacheATA[idx];
			return CacheIndicator<trader_algoritmico.Volume.ATA>(new trader_algoritmico.Volume.ATA(){ filter_percentile = filter_percentile, Colorbt = colorbt, Colorbighand = colorbighand, Colorclimax = colorclimax }, input, ref cacheATA);
		}

		public trader_algoritmico.Volume.Bands Bands(ISeries<double> input, int apilao, int filtro, double filtro2_ratio, int barrasEnFuturo, bool clustersDe1tick)
		{
			if (cacheBands != null)
				for (int idx = 0; idx < cacheBands.Length; idx++)
					if (cacheBands[idx].apilao == apilao && cacheBands[idx].filtro == filtro && cacheBands[idx].filtro2_ratio == filtro2_ratio && cacheBands[idx].barrasEnFuturo == barrasEnFuturo && cacheBands[idx].ClustersDe1tick == clustersDe1tick && cacheBands[idx].EqualsInput(input))
						return cacheBands[idx];
			return CacheIndicator<trader_algoritmico.Volume.Bands>(new trader_algoritmico.Volume.Bands(){ apilao = apilao, filtro = filtro, filtro2_ratio = filtro2_ratio, barrasEnFuturo = barrasEnFuturo, ClustersDe1tick = clustersDe1tick }, input, ref cacheBands);
		}

		public trader_algoritmico.Volume.CandlePOC CandlePOC(ISeries<double> input)
		{
			if (cacheCandlePOC != null)
				for (int idx = 0; idx < cacheCandlePOC.Length; idx++)
					if ( cacheCandlePOC[idx].EqualsInput(input))
						return cacheCandlePOC[idx];
			return CacheIndicator<trader_algoritmico.Volume.CandlePOC>(new trader_algoritmico.Volume.CandlePOC(), input, ref cacheCandlePOC);
		}

		public trader_algoritmico.Volume.DeltaDivergence DeltaDivergence(ISeries<double> input, Brush barColorDown, Brush barColorUp, Brush shadowColor, int shadowWidth, bool _setAlert, int minSize)
		{
			if (cacheDeltaDivergence != null)
				for (int idx = 0; idx < cacheDeltaDivergence.Length; idx++)
					if (cacheDeltaDivergence[idx].BarColorDown == barColorDown && cacheDeltaDivergence[idx].BarColorUp == barColorUp && cacheDeltaDivergence[idx].ShadowColor == shadowColor && cacheDeltaDivergence[idx].ShadowWidth == shadowWidth && cacheDeltaDivergence[idx]._setAlert == _setAlert && cacheDeltaDivergence[idx].MinSize == minSize && cacheDeltaDivergence[idx].EqualsInput(input))
						return cacheDeltaDivergence[idx];
			return CacheIndicator<trader_algoritmico.Volume.DeltaDivergence>(new trader_algoritmico.Volume.DeltaDivergence(){ BarColorDown = barColorDown, BarColorUp = barColorUp, ShadowColor = shadowColor, ShadowWidth = shadowWidth, _setAlert = _setAlert, MinSize = minSize }, input, ref cacheDeltaDivergence);
		}

		public trader_algoritmico.Volume.HeatMap_level2 HeatMap_level2(ISeries<double> input, string _sessionSaveFilePath, bool _saveSession, _HeatMapEnums.LadderRange _ladderRange, _HeatMapEnums.MarketOrdersCalculation _marketOrdersCalculation, _HeatMapEnums.MarketBarsCalculation _marketBarsCalculation, long _aggresiveMarketOrdersFilter, long _filterBigPendingOrders, float _filterPendingOrdersPer, _HeatMapEnums.MarketCummulativeCalculation _marketCummulativeCalculation)
		{
			if (cacheHeatMap_level2 != null)
				for (int idx = 0; idx < cacheHeatMap_level2.Length; idx++)
					if (cacheHeatMap_level2[idx]._SessionSaveFilePath == _sessionSaveFilePath && cacheHeatMap_level2[idx]._SaveSession == _saveSession && cacheHeatMap_level2[idx]._LadderRange == _ladderRange && cacheHeatMap_level2[idx]._MarketOrdersCalculation == _marketOrdersCalculation && cacheHeatMap_level2[idx]._MarketBarsCalculation == _marketBarsCalculation && cacheHeatMap_level2[idx]._AggresiveMarketOrdersFilter == _aggresiveMarketOrdersFilter && cacheHeatMap_level2[idx]._FilterBigPendingOrders == _filterBigPendingOrders && cacheHeatMap_level2[idx]._FilterPendingOrdersPer == _filterPendingOrdersPer && cacheHeatMap_level2[idx]._MarketCummulativeCalculation == _marketCummulativeCalculation && cacheHeatMap_level2[idx].EqualsInput(input))
						return cacheHeatMap_level2[idx];
			return CacheIndicator<trader_algoritmico.Volume.HeatMap_level2>(new trader_algoritmico.Volume.HeatMap_level2(){ _SessionSaveFilePath = _sessionSaveFilePath, _SaveSession = _saveSession, _LadderRange = _ladderRange, _MarketOrdersCalculation = _marketOrdersCalculation, _MarketBarsCalculation = _marketBarsCalculation, _AggresiveMarketOrdersFilter = _aggresiveMarketOrdersFilter, _FilterBigPendingOrders = _filterBigPendingOrders, _FilterPendingOrdersPer = _filterPendingOrdersPer, _MarketCummulativeCalculation = _marketCummulativeCalculation }, input, ref cacheHeatMap_level2);
		}

		public trader_algoritmico.Volume.JonReversionPoint JonReversionPoint(ISeries<double> input, Brush barColorDown, Brush barColorUp, Brush shadowColor, int shadowWidth, bool cumulativeDelta, int minSize, bool showDivs)
		{
			if (cacheJonReversionPoint != null)
				for (int idx = 0; idx < cacheJonReversionPoint.Length; idx++)
					if (cacheJonReversionPoint[idx].BarColorDown == barColorDown && cacheJonReversionPoint[idx].BarColorUp == barColorUp && cacheJonReversionPoint[idx].ShadowColor == shadowColor && cacheJonReversionPoint[idx].ShadowWidth == shadowWidth && cacheJonReversionPoint[idx].CumulativeDelta == cumulativeDelta && cacheJonReversionPoint[idx].MinSize == minSize && cacheJonReversionPoint[idx].ShowDivs == showDivs && cacheJonReversionPoint[idx].EqualsInput(input))
						return cacheJonReversionPoint[idx];
			return CacheIndicator<trader_algoritmico.Volume.JonReversionPoint>(new trader_algoritmico.Volume.JonReversionPoint(){ BarColorDown = barColorDown, BarColorUp = barColorUp, ShadowColor = shadowColor, ShadowWidth = shadowWidth, CumulativeDelta = cumulativeDelta, MinSize = minSize, ShowDivs = showDivs }, input, ref cacheJonReversionPoint);
		}

		public trader_algoritmico.Volume.OrderFlow OrderFlow(ISeries<double> input, _OrderFlowEnums.Calculation _oFmethod, _OrderFlowEnums.Representation _oFtakeTextFrom, _OrderFlowEnums.Style _oFStyle, bool _bands, bool _exausthion)
		{
			if (cacheOrderFlow != null)
				for (int idx = 0; idx < cacheOrderFlow.Length; idx++)
					if (cacheOrderFlow[idx]._OFmethod == _oFmethod && cacheOrderFlow[idx]._OFtakeTextFrom == _oFtakeTextFrom && cacheOrderFlow[idx]._OFStyle == _oFStyle && cacheOrderFlow[idx]._Bands == _bands && cacheOrderFlow[idx]._Exausthion == _exausthion && cacheOrderFlow[idx].EqualsInput(input))
						return cacheOrderFlow[idx];
			return CacheIndicator<trader_algoritmico.Volume.OrderFlow>(new trader_algoritmico.Volume.OrderFlow(){ _OFmethod = _oFmethod, _OFtakeTextFrom = _oFtakeTextFrom, _OFStyle = _oFStyle, _Bands = _bands, _Exausthion = _exausthion }, input, ref cacheOrderFlow);
		}

		public trader_algoritmico.Volume.PSC PSC(ISeries<double> input, bool psc, bool vel_igual, double mecha, int donde_vol, bool _volumeInsideBody)
		{
			if (cachePSC != null)
				for (int idx = 0; idx < cachePSC.Length; idx++)
					if (cachePSC[idx].psc == psc && cachePSC[idx].vel_igual == vel_igual && cachePSC[idx].mecha == mecha && cachePSC[idx].donde_vol == donde_vol && cachePSC[idx]._volumeInsideBody == _volumeInsideBody && cachePSC[idx].EqualsInput(input))
						return cachePSC[idx];
			return CacheIndicator<trader_algoritmico.Volume.PSC>(new trader_algoritmico.Volume.PSC(){ psc = psc, vel_igual = vel_igual, mecha = mecha, donde_vol = donde_vol, _volumeInsideBody = _volumeInsideBody }, input, ref cachePSC);
		}

		public trader_algoritmico.Volume.TapeReconstructor TapeReconstructor(ISeries<double> input, bool aggregateTrades, Brush colorForCircle)
		{
			if (cacheTapeReconstructor != null)
				for (int idx = 0; idx < cacheTapeReconstructor.Length; idx++)
					if (cacheTapeReconstructor[idx].AggregateTrades == aggregateTrades && cacheTapeReconstructor[idx].ColorForCircle == colorForCircle && cacheTapeReconstructor[idx].EqualsInput(input))
						return cacheTapeReconstructor[idx];
			return CacheIndicator<trader_algoritmico.Volume.TapeReconstructor>(new trader_algoritmico.Volume.TapeReconstructor(){ AggregateTrades = aggregateTrades, ColorForCircle = colorForCircle }, input, ref cacheTapeReconstructor);
		}

		public trader_algoritmico.Volume.TradeDetection TradeDetection(ISeries<double> input, __VolumeFilterProperties.Formula _formula, long _minVolumeFilter, bool _fillGeometry)
		{
			if (cacheTradeDetection != null)
				for (int idx = 0; idx < cacheTradeDetection.Length; idx++)
					if (cacheTradeDetection[idx]._Formula == _formula && cacheTradeDetection[idx]._MinVolumeFilter == _minVolumeFilter && cacheTradeDetection[idx]._FillGeometry == _fillGeometry && cacheTradeDetection[idx].EqualsInput(input))
						return cacheTradeDetection[idx];
			return CacheIndicator<trader_algoritmico.Volume.TradeDetection>(new trader_algoritmico.Volume.TradeDetection(){ _Formula = _formula, _MinVolumeFilter = _minVolumeFilter, _FillGeometry = _fillGeometry }, input, ref cacheTradeDetection);
		}

		public trader_algoritmico.Volume.VolumePro VolumePro(ISeries<double> input, _MarketAnalyzerEnums.Calculation _marketAnalyzerCalculation, int _period)
		{
			if (cacheVolumePro != null)
				for (int idx = 0; idx < cacheVolumePro.Length; idx++)
					if (cacheVolumePro[idx]._MarketAnalyzerCalculation == _marketAnalyzerCalculation && cacheVolumePro[idx]._Period == _period && cacheVolumePro[idx].EqualsInput(input))
						return cacheVolumePro[idx];
			return CacheIndicator<trader_algoritmico.Volume.VolumePro>(new trader_algoritmico.Volume.VolumePro(){ _MarketAnalyzerCalculation = _marketAnalyzerCalculation, _Period = _period }, input, ref cacheVolumePro);
		}

		public trader_algoritmico.Volume.VolumeProfileChart VolumeProfileChart(ISeries<double> input)
		{
			if (cacheVolumeProfileChart != null)
				for (int idx = 0; idx < cacheVolumeProfileChart.Length; idx++)
					if ( cacheVolumeProfileChart[idx].EqualsInput(input))
						return cacheVolumeProfileChart[idx];
			return CacheIndicator<trader_algoritmico.Volume.VolumeProfileChart>(new trader_algoritmico.Volume.VolumeProfileChart(), input, ref cacheVolumeProfileChart);
		}

		public trader_algoritmico.Volume.VolumeProfilePro VolumeProfilePro(ISeries<double> input, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.traderAlgoritmicoAddon.VolumeAnalysis.PeriodMode _periodMode, int _period, bool _showPOC, bool _showPOI, bool _realtimeHeuristic, float _pOCOpacity, float _pOIOpacity, float _selectionOpacity, float _eraseOpacity, float _textOpacity, SimpleFont _textFont, bool _showText, float _minFontWidth, float _minFontHeight)
		{
			if (cacheVolumeProfilePro != null)
				for (int idx = 0; idx < cacheVolumeProfilePro.Length; idx++)
					if (cacheVolumeProfilePro[idx]._PeriodMode == _periodMode && cacheVolumeProfilePro[idx]._Period == _period && cacheVolumeProfilePro[idx]._ShowPOC == _showPOC && cacheVolumeProfilePro[idx]._ShowPOI == _showPOI && cacheVolumeProfilePro[idx]._RealtimeHeuristic == _realtimeHeuristic && cacheVolumeProfilePro[idx]._POCOpacity == _pOCOpacity && cacheVolumeProfilePro[idx]._POIOpacity == _pOIOpacity && cacheVolumeProfilePro[idx]._SelectionOpacity == _selectionOpacity && cacheVolumeProfilePro[idx]._EraseOpacity == _eraseOpacity && cacheVolumeProfilePro[idx]._TextOpacity == _textOpacity && cacheVolumeProfilePro[idx]._TextFont == _textFont && cacheVolumeProfilePro[idx]._ShowText == _showText && cacheVolumeProfilePro[idx]._MinFontWidth == _minFontWidth && cacheVolumeProfilePro[idx]._MinFontHeight == _minFontHeight && cacheVolumeProfilePro[idx].EqualsInput(input))
						return cacheVolumeProfilePro[idx];
			return CacheIndicator<trader_algoritmico.Volume.VolumeProfilePro>(new trader_algoritmico.Volume.VolumeProfilePro(){ _PeriodMode = _periodMode, _Period = _period, _ShowPOC = _showPOC, _ShowPOI = _showPOI, _RealtimeHeuristic = _realtimeHeuristic, _POCOpacity = _pOCOpacity, _POIOpacity = _pOIOpacity, _SelectionOpacity = _selectionOpacity, _EraseOpacity = _eraseOpacity, _TextOpacity = _textOpacity, _TextFont = _textFont, _ShowText = _showText, _MinFontWidth = _minFontWidth, _MinFontHeight = _minFontHeight }, input, ref cacheVolumeProfilePro);
		}

		public trader_algoritmico.Volume.VPOC VPOC(ISeries<double> input, DateTime horaInicio)
		{
			if (cacheVPOC != null)
				for (int idx = 0; idx < cacheVPOC.Length; idx++)
					if (cacheVPOC[idx].HoraInicio == horaInicio && cacheVPOC[idx].EqualsInput(input))
						return cacheVPOC[idx];
			return CacheIndicator<trader_algoritmico.Volume.VPOC>(new trader_algoritmico.Volume.VPOC(){ HoraInicio = horaInicio }, input, ref cacheVPOC);
		}

		public trader_algoritmico.Volume.VWAP VWAP(ISeries<double> input, DateTime horaInicio)
		{
			if (cacheVWAP != null)
				for (int idx = 0; idx < cacheVWAP.Length; idx++)
					if (cacheVWAP[idx].HoraInicio == horaInicio && cacheVWAP[idx].EqualsInput(input))
						return cacheVWAP[idx];
			return CacheIndicator<trader_algoritmico.Volume.VWAP>(new trader_algoritmico.Volume.VWAP(){ HoraInicio = horaInicio }, input, ref cacheVWAP);
		}

	}
}

namespace NinjaTrader.NinjaScript.MarketAnalyzerColumns
{
	public partial class MarketAnalyzerColumn : MarketAnalyzerColumnBase
	{
		
		public Indicators.trader_algoritmico.Price.BilliardBands BilliardBands(int numeroBandas)
		{
			return indicator.BilliardBands(Input, numeroBandas);
		}

		public Indicators.trader_algoritmico.Price.DynamicSupportResistance DynamicSupportResistance()
		{
			return indicator.DynamicSupportResistance(Input);
		}

		public Indicators.trader_algoritmico.Price.Esperanzag Esperanzag(string indicatorName, bool showIndicatorName, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Price.SwingStyle swingType, double swingSize, int dtbStrength, bool useCloseValues, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Price.SwingLengthStyle swingLengthType, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Price.SwingDurationStyle swingDurationType, bool showSwingPrice, bool showSwingLabel, bool showSwingPercent, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Price.SwingTimeStyle swingTimeType, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Price.SwingVolumeStyle swingVolumeType, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Price.VisualizationStyle visualizationType, NinjaTrader.Gui.Tools.SimpleFont textFont, int textOffsetLength, int textOffsetVolume, int textOffsetPrice, int textOffsetLabel, int textOffsetTime, int textOffsetPercent, DashStyleHelper linesStyle, int linesWidth, bool ignoreInsideBars, bool useBreakouts)
		{
			return indicator.Esperanzag(Input, indicatorName, showIndicatorName, swingType, swingSize, dtbStrength, useCloseValues, swingLengthType, swingDurationType, showSwingPrice, showSwingLabel, showSwingPercent, swingTimeType, swingVolumeType, visualizationType, textFont, textOffsetLength, textOffsetVolume, textOffsetPrice, textOffsetLabel, textOffsetTime, textOffsetPercent, linesStyle, linesWidth, ignoreInsideBars, useBreakouts);
		}

		public Indicators.trader_algoritmico.Price.LiquidityLevels LiquidityLevels(bool activateLL, bool deleteLine, bool activateFVG, bool useFVGDataSeries, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Price.FVGPeriodTypes fVGBarsPeriodType, int fVGSeriesPeriod, int maxBars, bool useATR, int aTRPeriod, double impulseFactor, double minimumFVGSize, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Price.FVGFillType fillType, bool hideFilledGaps, bool displayCE, int activeAreaOpacity, int filledAreaOpacity, bool drawLabel)
		{
			return indicator.LiquidityLevels(Input, activateLL, deleteLine, activateFVG, useFVGDataSeries, fVGBarsPeriodType, fVGSeriesPeriod, maxBars, useATR, aTRPeriod, impulseFactor, minimumFVGSize, fillType, hideFilledGaps, displayCE, activeAreaOpacity, filledAreaOpacity, drawLabel);
		}

		public Indicators.trader_algoritmico.Price.MaxFO MaxFO(DateTime startTime, DateTime endTime)
		{
			return indicator.MaxFO(Input, startTime, endTime);
		}

		public Indicators.trader_algoritmico.Price.PowerTrend PowerTrend()
		{
			return indicator.PowerTrend(Input);
		}

		public Indicators.trader_algoritmico.Price.PriceActionTrail PriceActionTrail()
		{
			return indicator.PriceActionTrail(Input);
		}

		public Indicators.trader_algoritmico.Price.TimePivots TimePivots(bool showWeeklyPivots, bool showMonthlyPivot, bool showOpen, bool showPivot)
		{
			return indicator.TimePivots(Input, showWeeklyPivots, showMonthlyPivot, showOpen, showPivot);
		}

		public Indicators.trader_algoritmico.Price.TrendFilter TrendFilter(int eMA1, int eMA2, int eMA3, bool filtro_vpoc)
		{
			return indicator.TrendFilter(Input, eMA1, eMA2, eMA3, filtro_vpoc);
		}

		public Indicators.trader_algoritmico.Price.WhereTo WhereTo(string whereToXX1, string whereToXX2, string whereToXX3)
		{
			return indicator.WhereTo(Input, whereToXX1, whereToXX2, whereToXX3);
		}

		public Indicators.trader_algoritmico.Utilities.DrawAlert DrawAlert()
		{
			return indicator.DrawAlert(Input);
		}

		public Indicators.trader_algoritmico.Utilities.Info Info(int letraSize, Brush letraColor, bool mostrarSpread, bool mostrarNombreCuentaActual, bool mostrarTR, bool mostrarTickSize, bool showPnl, Brush defaultTextColor, Brush inProfitColor, Brush inLossColor, Brush activeOrderColor, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Utilities.Info.textPosition basisTextLocation, bool showNetPriceChange, Cbi.PerformanceUnit unit, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Utilities.Info.textPosition location)
		{
			return indicator.Info(Input, letraSize, letraColor, mostrarSpread, mostrarNombreCuentaActual, mostrarTR, mostrarTickSize, showPnl, defaultTextColor, inProfitColor, inLossColor, activeOrderColor, basisTextLocation, showNetPriceChange, unit, location);
		}

		public Indicators.trader_algoritmico.Utilities.JoiaRenkoPrice JoiaRenkoPrice()
		{
			return indicator.JoiaRenkoPrice(Input);
		}

		public Indicators.trader_algoritmico.Utilities.OpeningMarker OpeningMarker(DateTime lineTime, Brush lineColor, DashStyleHelper lineDashStyle, int lineThickness, int barToLineOffsetInTicks)
		{
			return indicator.OpeningMarker(Input, lineTime, lineColor, lineDashStyle, lineThickness, barToLineOffsetInTicks);
		}

		public Indicators.trader_algoritmico.Utilities.TickElectrifier TickElectrifier(int frecuenciaActualizacion)
		{
			return indicator.TickElectrifier(Input, frecuenciaActualizacion);
		}

		public Indicators.trader_algoritmico.Utilities.TradeManager TradeManager(string selectedAccountName, double _maxDailyProfit, double _maxDailyLoss, int contracts_quantity, bool _usePercentageInsteadOfContracts, double _percentageOfBalanceForTrade, bool _useAtm, bool _tradingDrawnLevel, int usePredSL, int usePredTP, bool _set_BE, int _be_ticks_offset, bool _set_Trailing_Stop, int _tr_start, int _tr_offset, bool _setChangeTSafterProfit, double _changeTSafterProfit, bool _allowEnterOnlyIfVPOCinFavor, bool _allowEnterOnlyIfVWAPinFavor, bool _allowEnterOnlyIfEMA20inFavor, bool _allowEnterOnlyIfBtinFavor, bool _setExitOnBigTrade, bool _setExitOnVPOC, bool _setExitOnVSC, bool _setExitOnClimax)
		{
			return indicator.TradeManager(Input, selectedAccountName, _maxDailyProfit, _maxDailyLoss, contracts_quantity, _usePercentageInsteadOfContracts, _percentageOfBalanceForTrade, _useAtm, _tradingDrawnLevel, usePredSL, usePredTP, _set_BE, _be_ticks_offset, _set_Trailing_Stop, _tr_start, _tr_offset, _setChangeTSafterProfit, _changeTSafterProfit, _allowEnterOnlyIfVPOCinFavor, _allowEnterOnlyIfVWAPinFavor, _allowEnterOnlyIfEMA20inFavor, _allowEnterOnlyIfBtinFavor, _setExitOnBigTrade, _setExitOnVPOC, _setExitOnVSC, _setExitOnClimax);
		}

		public Indicators.trader_algoritmico.Volume.ATA ATA(int filter_percentile, Brush colorbt, Brush colorbighand, Brush colorclimax)
		{
			return indicator.ATA(Input, filter_percentile, colorbt, colorbighand, colorclimax);
		}

		public Indicators.trader_algoritmico.Volume.Bands Bands(int apilao, int filtro, double filtro2_ratio, int barrasEnFuturo, bool clustersDe1tick)
		{
			return indicator.Bands(Input, apilao, filtro, filtro2_ratio, barrasEnFuturo, clustersDe1tick);
		}

		public Indicators.trader_algoritmico.Volume.CandlePOC CandlePOC()
		{
			return indicator.CandlePOC(Input);
		}

		public Indicators.trader_algoritmico.Volume.DeltaDivergence DeltaDivergence(Brush barColorDown, Brush barColorUp, Brush shadowColor, int shadowWidth, bool _setAlert, int minSize)
		{
			return indicator.DeltaDivergence(Input, barColorDown, barColorUp, shadowColor, shadowWidth, _setAlert, minSize);
		}

		public Indicators.trader_algoritmico.Volume.HeatMap_level2 HeatMap_level2(string _sessionSaveFilePath, bool _saveSession, _HeatMapEnums.LadderRange _ladderRange, _HeatMapEnums.MarketOrdersCalculation _marketOrdersCalculation, _HeatMapEnums.MarketBarsCalculation _marketBarsCalculation, long _aggresiveMarketOrdersFilter, long _filterBigPendingOrders, float _filterPendingOrdersPer, _HeatMapEnums.MarketCummulativeCalculation _marketCummulativeCalculation)
		{
			return indicator.HeatMap_level2(Input, _sessionSaveFilePath, _saveSession, _ladderRange, _marketOrdersCalculation, _marketBarsCalculation, _aggresiveMarketOrdersFilter, _filterBigPendingOrders, _filterPendingOrdersPer, _marketCummulativeCalculation);
		}

		public Indicators.trader_algoritmico.Volume.JonReversionPoint JonReversionPoint(Brush barColorDown, Brush barColorUp, Brush shadowColor, int shadowWidth, bool cumulativeDelta, int minSize, bool showDivs)
		{
			return indicator.JonReversionPoint(Input, barColorDown, barColorUp, shadowColor, shadowWidth, cumulativeDelta, minSize, showDivs);
		}

		public Indicators.trader_algoritmico.Volume.OrderFlow OrderFlow(_OrderFlowEnums.Calculation _oFmethod, _OrderFlowEnums.Representation _oFtakeTextFrom, _OrderFlowEnums.Style _oFStyle, bool _bands, bool _exausthion)
		{
			return indicator.OrderFlow(Input, _oFmethod, _oFtakeTextFrom, _oFStyle, _bands, _exausthion);
		}

		public Indicators.trader_algoritmico.Volume.PSC PSC(bool psc, bool vel_igual, double mecha, int donde_vol, bool _volumeInsideBody)
		{
			return indicator.PSC(Input, psc, vel_igual, mecha, donde_vol, _volumeInsideBody);
		}

		public Indicators.trader_algoritmico.Volume.TapeReconstructor TapeReconstructor(bool aggregateTrades, Brush colorForCircle)
		{
			return indicator.TapeReconstructor(Input, aggregateTrades, colorForCircle);
		}

		public Indicators.trader_algoritmico.Volume.TradeDetection TradeDetection(__VolumeFilterProperties.Formula _formula, long _minVolumeFilter, bool _fillGeometry)
		{
			return indicator.TradeDetection(Input, _formula, _minVolumeFilter, _fillGeometry);
		}

		public Indicators.trader_algoritmico.Volume.VolumePro VolumePro(_MarketAnalyzerEnums.Calculation _marketAnalyzerCalculation, int _period)
		{
			return indicator.VolumePro(Input, _marketAnalyzerCalculation, _period);
		}

		public Indicators.trader_algoritmico.Volume.VolumeProfileChart VolumeProfileChart()
		{
			return indicator.VolumeProfileChart(Input);
		}

		public Indicators.trader_algoritmico.Volume.VolumeProfilePro VolumeProfilePro(NinjaTrader.NinjaScript.Indicators.trader_algoritmico.traderAlgoritmicoAddon.VolumeAnalysis.PeriodMode _periodMode, int _period, bool _showPOC, bool _showPOI, bool _realtimeHeuristic, float _pOCOpacity, float _pOIOpacity, float _selectionOpacity, float _eraseOpacity, float _textOpacity, SimpleFont _textFont, bool _showText, float _minFontWidth, float _minFontHeight)
		{
			return indicator.VolumeProfilePro(Input, _periodMode, _period, _showPOC, _showPOI, _realtimeHeuristic, _pOCOpacity, _pOIOpacity, _selectionOpacity, _eraseOpacity, _textOpacity, _textFont, _showText, _minFontWidth, _minFontHeight);
		}

		public Indicators.trader_algoritmico.Volume.VPOC VPOC(DateTime horaInicio)
		{
			return indicator.VPOC(Input, horaInicio);
		}

		public Indicators.trader_algoritmico.Volume.VWAP VWAP(DateTime horaInicio)
		{
			return indicator.VWAP(Input, horaInicio);
		}


		
		public Indicators.trader_algoritmico.Price.BilliardBands BilliardBands(ISeries<double> input , int numeroBandas)
		{
			return indicator.BilliardBands(input, numeroBandas);
		}

		public Indicators.trader_algoritmico.Price.DynamicSupportResistance DynamicSupportResistance(ISeries<double> input )
		{
			return indicator.DynamicSupportResistance(input);
		}

		public Indicators.trader_algoritmico.Price.Esperanzag Esperanzag(ISeries<double> input , string indicatorName, bool showIndicatorName, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Price.SwingStyle swingType, double swingSize, int dtbStrength, bool useCloseValues, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Price.SwingLengthStyle swingLengthType, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Price.SwingDurationStyle swingDurationType, bool showSwingPrice, bool showSwingLabel, bool showSwingPercent, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Price.SwingTimeStyle swingTimeType, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Price.SwingVolumeStyle swingVolumeType, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Price.VisualizationStyle visualizationType, NinjaTrader.Gui.Tools.SimpleFont textFont, int textOffsetLength, int textOffsetVolume, int textOffsetPrice, int textOffsetLabel, int textOffsetTime, int textOffsetPercent, DashStyleHelper linesStyle, int linesWidth, bool ignoreInsideBars, bool useBreakouts)
		{
			return indicator.Esperanzag(input, indicatorName, showIndicatorName, swingType, swingSize, dtbStrength, useCloseValues, swingLengthType, swingDurationType, showSwingPrice, showSwingLabel, showSwingPercent, swingTimeType, swingVolumeType, visualizationType, textFont, textOffsetLength, textOffsetVolume, textOffsetPrice, textOffsetLabel, textOffsetTime, textOffsetPercent, linesStyle, linesWidth, ignoreInsideBars, useBreakouts);
		}

		public Indicators.trader_algoritmico.Price.LiquidityLevels LiquidityLevels(ISeries<double> input , bool activateLL, bool deleteLine, bool activateFVG, bool useFVGDataSeries, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Price.FVGPeriodTypes fVGBarsPeriodType, int fVGSeriesPeriod, int maxBars, bool useATR, int aTRPeriod, double impulseFactor, double minimumFVGSize, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Price.FVGFillType fillType, bool hideFilledGaps, bool displayCE, int activeAreaOpacity, int filledAreaOpacity, bool drawLabel)
		{
			return indicator.LiquidityLevels(input, activateLL, deleteLine, activateFVG, useFVGDataSeries, fVGBarsPeriodType, fVGSeriesPeriod, maxBars, useATR, aTRPeriod, impulseFactor, minimumFVGSize, fillType, hideFilledGaps, displayCE, activeAreaOpacity, filledAreaOpacity, drawLabel);
		}

		public Indicators.trader_algoritmico.Price.MaxFO MaxFO(ISeries<double> input , DateTime startTime, DateTime endTime)
		{
			return indicator.MaxFO(input, startTime, endTime);
		}

		public Indicators.trader_algoritmico.Price.PowerTrend PowerTrend(ISeries<double> input )
		{
			return indicator.PowerTrend(input);
		}

		public Indicators.trader_algoritmico.Price.PriceActionTrail PriceActionTrail(ISeries<double> input )
		{
			return indicator.PriceActionTrail(input);
		}

		public Indicators.trader_algoritmico.Price.TimePivots TimePivots(ISeries<double> input , bool showWeeklyPivots, bool showMonthlyPivot, bool showOpen, bool showPivot)
		{
			return indicator.TimePivots(input, showWeeklyPivots, showMonthlyPivot, showOpen, showPivot);
		}

		public Indicators.trader_algoritmico.Price.TrendFilter TrendFilter(ISeries<double> input , int eMA1, int eMA2, int eMA3, bool filtro_vpoc)
		{
			return indicator.TrendFilter(input, eMA1, eMA2, eMA3, filtro_vpoc);
		}

		public Indicators.trader_algoritmico.Price.WhereTo WhereTo(ISeries<double> input , string whereToXX1, string whereToXX2, string whereToXX3)
		{
			return indicator.WhereTo(input, whereToXX1, whereToXX2, whereToXX3);
		}

		public Indicators.trader_algoritmico.Utilities.DrawAlert DrawAlert(ISeries<double> input )
		{
			return indicator.DrawAlert(input);
		}

		public Indicators.trader_algoritmico.Utilities.Info Info(ISeries<double> input , int letraSize, Brush letraColor, bool mostrarSpread, bool mostrarNombreCuentaActual, bool mostrarTR, bool mostrarTickSize, bool showPnl, Brush defaultTextColor, Brush inProfitColor, Brush inLossColor, Brush activeOrderColor, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Utilities.Info.textPosition basisTextLocation, bool showNetPriceChange, Cbi.PerformanceUnit unit, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Utilities.Info.textPosition location)
		{
			return indicator.Info(input, letraSize, letraColor, mostrarSpread, mostrarNombreCuentaActual, mostrarTR, mostrarTickSize, showPnl, defaultTextColor, inProfitColor, inLossColor, activeOrderColor, basisTextLocation, showNetPriceChange, unit, location);
		}

		public Indicators.trader_algoritmico.Utilities.JoiaRenkoPrice JoiaRenkoPrice(ISeries<double> input )
		{
			return indicator.JoiaRenkoPrice(input);
		}

		public Indicators.trader_algoritmico.Utilities.OpeningMarker OpeningMarker(ISeries<double> input , DateTime lineTime, Brush lineColor, DashStyleHelper lineDashStyle, int lineThickness, int barToLineOffsetInTicks)
		{
			return indicator.OpeningMarker(input, lineTime, lineColor, lineDashStyle, lineThickness, barToLineOffsetInTicks);
		}

		public Indicators.trader_algoritmico.Utilities.TickElectrifier TickElectrifier(ISeries<double> input , int frecuenciaActualizacion)
		{
			return indicator.TickElectrifier(input, frecuenciaActualizacion);
		}

		public Indicators.trader_algoritmico.Utilities.TradeManager TradeManager(ISeries<double> input , string selectedAccountName, double _maxDailyProfit, double _maxDailyLoss, int contracts_quantity, bool _usePercentageInsteadOfContracts, double _percentageOfBalanceForTrade, bool _useAtm, bool _tradingDrawnLevel, int usePredSL, int usePredTP, bool _set_BE, int _be_ticks_offset, bool _set_Trailing_Stop, int _tr_start, int _tr_offset, bool _setChangeTSafterProfit, double _changeTSafterProfit, bool _allowEnterOnlyIfVPOCinFavor, bool _allowEnterOnlyIfVWAPinFavor, bool _allowEnterOnlyIfEMA20inFavor, bool _allowEnterOnlyIfBtinFavor, bool _setExitOnBigTrade, bool _setExitOnVPOC, bool _setExitOnVSC, bool _setExitOnClimax)
		{
			return indicator.TradeManager(input, selectedAccountName, _maxDailyProfit, _maxDailyLoss, contracts_quantity, _usePercentageInsteadOfContracts, _percentageOfBalanceForTrade, _useAtm, _tradingDrawnLevel, usePredSL, usePredTP, _set_BE, _be_ticks_offset, _set_Trailing_Stop, _tr_start, _tr_offset, _setChangeTSafterProfit, _changeTSafterProfit, _allowEnterOnlyIfVPOCinFavor, _allowEnterOnlyIfVWAPinFavor, _allowEnterOnlyIfEMA20inFavor, _allowEnterOnlyIfBtinFavor, _setExitOnBigTrade, _setExitOnVPOC, _setExitOnVSC, _setExitOnClimax);
		}

		public Indicators.trader_algoritmico.Volume.ATA ATA(ISeries<double> input , int filter_percentile, Brush colorbt, Brush colorbighand, Brush colorclimax)
		{
			return indicator.ATA(input, filter_percentile, colorbt, colorbighand, colorclimax);
		}

		public Indicators.trader_algoritmico.Volume.Bands Bands(ISeries<double> input , int apilao, int filtro, double filtro2_ratio, int barrasEnFuturo, bool clustersDe1tick)
		{
			return indicator.Bands(input, apilao, filtro, filtro2_ratio, barrasEnFuturo, clustersDe1tick);
		}

		public Indicators.trader_algoritmico.Volume.CandlePOC CandlePOC(ISeries<double> input )
		{
			return indicator.CandlePOC(input);
		}

		public Indicators.trader_algoritmico.Volume.DeltaDivergence DeltaDivergence(ISeries<double> input , Brush barColorDown, Brush barColorUp, Brush shadowColor, int shadowWidth, bool _setAlert, int minSize)
		{
			return indicator.DeltaDivergence(input, barColorDown, barColorUp, shadowColor, shadowWidth, _setAlert, minSize);
		}

		public Indicators.trader_algoritmico.Volume.HeatMap_level2 HeatMap_level2(ISeries<double> input , string _sessionSaveFilePath, bool _saveSession, _HeatMapEnums.LadderRange _ladderRange, _HeatMapEnums.MarketOrdersCalculation _marketOrdersCalculation, _HeatMapEnums.MarketBarsCalculation _marketBarsCalculation, long _aggresiveMarketOrdersFilter, long _filterBigPendingOrders, float _filterPendingOrdersPer, _HeatMapEnums.MarketCummulativeCalculation _marketCummulativeCalculation)
		{
			return indicator.HeatMap_level2(input, _sessionSaveFilePath, _saveSession, _ladderRange, _marketOrdersCalculation, _marketBarsCalculation, _aggresiveMarketOrdersFilter, _filterBigPendingOrders, _filterPendingOrdersPer, _marketCummulativeCalculation);
		}

		public Indicators.trader_algoritmico.Volume.JonReversionPoint JonReversionPoint(ISeries<double> input , Brush barColorDown, Brush barColorUp, Brush shadowColor, int shadowWidth, bool cumulativeDelta, int minSize, bool showDivs)
		{
			return indicator.JonReversionPoint(input, barColorDown, barColorUp, shadowColor, shadowWidth, cumulativeDelta, minSize, showDivs);
		}

		public Indicators.trader_algoritmico.Volume.OrderFlow OrderFlow(ISeries<double> input , _OrderFlowEnums.Calculation _oFmethod, _OrderFlowEnums.Representation _oFtakeTextFrom, _OrderFlowEnums.Style _oFStyle, bool _bands, bool _exausthion)
		{
			return indicator.OrderFlow(input, _oFmethod, _oFtakeTextFrom, _oFStyle, _bands, _exausthion);
		}

		public Indicators.trader_algoritmico.Volume.PSC PSC(ISeries<double> input , bool psc, bool vel_igual, double mecha, int donde_vol, bool _volumeInsideBody)
		{
			return indicator.PSC(input, psc, vel_igual, mecha, donde_vol, _volumeInsideBody);
		}

		public Indicators.trader_algoritmico.Volume.TapeReconstructor TapeReconstructor(ISeries<double> input , bool aggregateTrades, Brush colorForCircle)
		{
			return indicator.TapeReconstructor(input, aggregateTrades, colorForCircle);
		}

		public Indicators.trader_algoritmico.Volume.TradeDetection TradeDetection(ISeries<double> input , __VolumeFilterProperties.Formula _formula, long _minVolumeFilter, bool _fillGeometry)
		{
			return indicator.TradeDetection(input, _formula, _minVolumeFilter, _fillGeometry);
		}

		public Indicators.trader_algoritmico.Volume.VolumePro VolumePro(ISeries<double> input , _MarketAnalyzerEnums.Calculation _marketAnalyzerCalculation, int _period)
		{
			return indicator.VolumePro(input, _marketAnalyzerCalculation, _period);
		}

		public Indicators.trader_algoritmico.Volume.VolumeProfileChart VolumeProfileChart(ISeries<double> input )
		{
			return indicator.VolumeProfileChart(input);
		}

		public Indicators.trader_algoritmico.Volume.VolumeProfilePro VolumeProfilePro(ISeries<double> input , NinjaTrader.NinjaScript.Indicators.trader_algoritmico.traderAlgoritmicoAddon.VolumeAnalysis.PeriodMode _periodMode, int _period, bool _showPOC, bool _showPOI, bool _realtimeHeuristic, float _pOCOpacity, float _pOIOpacity, float _selectionOpacity, float _eraseOpacity, float _textOpacity, SimpleFont _textFont, bool _showText, float _minFontWidth, float _minFontHeight)
		{
			return indicator.VolumeProfilePro(input, _periodMode, _period, _showPOC, _showPOI, _realtimeHeuristic, _pOCOpacity, _pOIOpacity, _selectionOpacity, _eraseOpacity, _textOpacity, _textFont, _showText, _minFontWidth, _minFontHeight);
		}

		public Indicators.trader_algoritmico.Volume.VPOC VPOC(ISeries<double> input , DateTime horaInicio)
		{
			return indicator.VPOC(input, horaInicio);
		}

		public Indicators.trader_algoritmico.Volume.VWAP VWAP(ISeries<double> input , DateTime horaInicio)
		{
			return indicator.VWAP(input, horaInicio);
		}
	
	}
}

namespace NinjaTrader.NinjaScript.Strategies
{
	public partial class Strategy : NinjaTrader.Gui.NinjaScript.StrategyRenderBase
	{
		
		public Indicators.trader_algoritmico.Price.BilliardBands BilliardBands(int numeroBandas)
		{
			return indicator.BilliardBands(Input, numeroBandas);
		}

		public Indicators.trader_algoritmico.Price.DynamicSupportResistance DynamicSupportResistance()
		{
			return indicator.DynamicSupportResistance(Input);
		}

		public Indicators.trader_algoritmico.Price.Esperanzag Esperanzag(string indicatorName, bool showIndicatorName, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Price.SwingStyle swingType, double swingSize, int dtbStrength, bool useCloseValues, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Price.SwingLengthStyle swingLengthType, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Price.SwingDurationStyle swingDurationType, bool showSwingPrice, bool showSwingLabel, bool showSwingPercent, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Price.SwingTimeStyle swingTimeType, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Price.SwingVolumeStyle swingVolumeType, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Price.VisualizationStyle visualizationType, NinjaTrader.Gui.Tools.SimpleFont textFont, int textOffsetLength, int textOffsetVolume, int textOffsetPrice, int textOffsetLabel, int textOffsetTime, int textOffsetPercent, DashStyleHelper linesStyle, int linesWidth, bool ignoreInsideBars, bool useBreakouts)
		{
			return indicator.Esperanzag(Input, indicatorName, showIndicatorName, swingType, swingSize, dtbStrength, useCloseValues, swingLengthType, swingDurationType, showSwingPrice, showSwingLabel, showSwingPercent, swingTimeType, swingVolumeType, visualizationType, textFont, textOffsetLength, textOffsetVolume, textOffsetPrice, textOffsetLabel, textOffsetTime, textOffsetPercent, linesStyle, linesWidth, ignoreInsideBars, useBreakouts);
		}

		public Indicators.trader_algoritmico.Price.LiquidityLevels LiquidityLevels(bool activateLL, bool deleteLine, bool activateFVG, bool useFVGDataSeries, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Price.FVGPeriodTypes fVGBarsPeriodType, int fVGSeriesPeriod, int maxBars, bool useATR, int aTRPeriod, double impulseFactor, double minimumFVGSize, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Price.FVGFillType fillType, bool hideFilledGaps, bool displayCE, int activeAreaOpacity, int filledAreaOpacity, bool drawLabel)
		{
			return indicator.LiquidityLevels(Input, activateLL, deleteLine, activateFVG, useFVGDataSeries, fVGBarsPeriodType, fVGSeriesPeriod, maxBars, useATR, aTRPeriod, impulseFactor, minimumFVGSize, fillType, hideFilledGaps, displayCE, activeAreaOpacity, filledAreaOpacity, drawLabel);
		}

		public Indicators.trader_algoritmico.Price.MaxFO MaxFO(DateTime startTime, DateTime endTime)
		{
			return indicator.MaxFO(Input, startTime, endTime);
		}

		public Indicators.trader_algoritmico.Price.PowerTrend PowerTrend()
		{
			return indicator.PowerTrend(Input);
		}

		public Indicators.trader_algoritmico.Price.PriceActionTrail PriceActionTrail()
		{
			return indicator.PriceActionTrail(Input);
		}

		public Indicators.trader_algoritmico.Price.TimePivots TimePivots(bool showWeeklyPivots, bool showMonthlyPivot, bool showOpen, bool showPivot)
		{
			return indicator.TimePivots(Input, showWeeklyPivots, showMonthlyPivot, showOpen, showPivot);
		}

		public Indicators.trader_algoritmico.Price.TrendFilter TrendFilter(int eMA1, int eMA2, int eMA3, bool filtro_vpoc)
		{
			return indicator.TrendFilter(Input, eMA1, eMA2, eMA3, filtro_vpoc);
		}

		public Indicators.trader_algoritmico.Price.WhereTo WhereTo(string whereToXX1, string whereToXX2, string whereToXX3)
		{
			return indicator.WhereTo(Input, whereToXX1, whereToXX2, whereToXX3);
		}

		public Indicators.trader_algoritmico.Utilities.DrawAlert DrawAlert()
		{
			return indicator.DrawAlert(Input);
		}

		public Indicators.trader_algoritmico.Utilities.Info Info(int letraSize, Brush letraColor, bool mostrarSpread, bool mostrarNombreCuentaActual, bool mostrarTR, bool mostrarTickSize, bool showPnl, Brush defaultTextColor, Brush inProfitColor, Brush inLossColor, Brush activeOrderColor, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Utilities.Info.textPosition basisTextLocation, bool showNetPriceChange, Cbi.PerformanceUnit unit, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Utilities.Info.textPosition location)
		{
			return indicator.Info(Input, letraSize, letraColor, mostrarSpread, mostrarNombreCuentaActual, mostrarTR, mostrarTickSize, showPnl, defaultTextColor, inProfitColor, inLossColor, activeOrderColor, basisTextLocation, showNetPriceChange, unit, location);
		}

		public Indicators.trader_algoritmico.Utilities.JoiaRenkoPrice JoiaRenkoPrice()
		{
			return indicator.JoiaRenkoPrice(Input);
		}

		public Indicators.trader_algoritmico.Utilities.OpeningMarker OpeningMarker(DateTime lineTime, Brush lineColor, DashStyleHelper lineDashStyle, int lineThickness, int barToLineOffsetInTicks)
		{
			return indicator.OpeningMarker(Input, lineTime, lineColor, lineDashStyle, lineThickness, barToLineOffsetInTicks);
		}

		public Indicators.trader_algoritmico.Utilities.TickElectrifier TickElectrifier(int frecuenciaActualizacion)
		{
			return indicator.TickElectrifier(Input, frecuenciaActualizacion);
		}

		public Indicators.trader_algoritmico.Utilities.TradeManager TradeManager(string selectedAccountName, double _maxDailyProfit, double _maxDailyLoss, int contracts_quantity, bool _usePercentageInsteadOfContracts, double _percentageOfBalanceForTrade, bool _useAtm, bool _tradingDrawnLevel, int usePredSL, int usePredTP, bool _set_BE, int _be_ticks_offset, bool _set_Trailing_Stop, int _tr_start, int _tr_offset, bool _setChangeTSafterProfit, double _changeTSafterProfit, bool _allowEnterOnlyIfVPOCinFavor, bool _allowEnterOnlyIfVWAPinFavor, bool _allowEnterOnlyIfEMA20inFavor, bool _allowEnterOnlyIfBtinFavor, bool _setExitOnBigTrade, bool _setExitOnVPOC, bool _setExitOnVSC, bool _setExitOnClimax)
		{
			return indicator.TradeManager(Input, selectedAccountName, _maxDailyProfit, _maxDailyLoss, contracts_quantity, _usePercentageInsteadOfContracts, _percentageOfBalanceForTrade, _useAtm, _tradingDrawnLevel, usePredSL, usePredTP, _set_BE, _be_ticks_offset, _set_Trailing_Stop, _tr_start, _tr_offset, _setChangeTSafterProfit, _changeTSafterProfit, _allowEnterOnlyIfVPOCinFavor, _allowEnterOnlyIfVWAPinFavor, _allowEnterOnlyIfEMA20inFavor, _allowEnterOnlyIfBtinFavor, _setExitOnBigTrade, _setExitOnVPOC, _setExitOnVSC, _setExitOnClimax);
		}

		public Indicators.trader_algoritmico.Volume.ATA ATA(int filter_percentile, Brush colorbt, Brush colorbighand, Brush colorclimax)
		{
			return indicator.ATA(Input, filter_percentile, colorbt, colorbighand, colorclimax);
		}

		public Indicators.trader_algoritmico.Volume.Bands Bands(int apilao, int filtro, double filtro2_ratio, int barrasEnFuturo, bool clustersDe1tick)
		{
			return indicator.Bands(Input, apilao, filtro, filtro2_ratio, barrasEnFuturo, clustersDe1tick);
		}

		public Indicators.trader_algoritmico.Volume.CandlePOC CandlePOC()
		{
			return indicator.CandlePOC(Input);
		}

		public Indicators.trader_algoritmico.Volume.DeltaDivergence DeltaDivergence(Brush barColorDown, Brush barColorUp, Brush shadowColor, int shadowWidth, bool _setAlert, int minSize)
		{
			return indicator.DeltaDivergence(Input, barColorDown, barColorUp, shadowColor, shadowWidth, _setAlert, minSize);
		}

		public Indicators.trader_algoritmico.Volume.HeatMap_level2 HeatMap_level2(string _sessionSaveFilePath, bool _saveSession, _HeatMapEnums.LadderRange _ladderRange, _HeatMapEnums.MarketOrdersCalculation _marketOrdersCalculation, _HeatMapEnums.MarketBarsCalculation _marketBarsCalculation, long _aggresiveMarketOrdersFilter, long _filterBigPendingOrders, float _filterPendingOrdersPer, _HeatMapEnums.MarketCummulativeCalculation _marketCummulativeCalculation)
		{
			return indicator.HeatMap_level2(Input, _sessionSaveFilePath, _saveSession, _ladderRange, _marketOrdersCalculation, _marketBarsCalculation, _aggresiveMarketOrdersFilter, _filterBigPendingOrders, _filterPendingOrdersPer, _marketCummulativeCalculation);
		}

		public Indicators.trader_algoritmico.Volume.JonReversionPoint JonReversionPoint(Brush barColorDown, Brush barColorUp, Brush shadowColor, int shadowWidth, bool cumulativeDelta, int minSize, bool showDivs)
		{
			return indicator.JonReversionPoint(Input, barColorDown, barColorUp, shadowColor, shadowWidth, cumulativeDelta, minSize, showDivs);
		}

		public Indicators.trader_algoritmico.Volume.OrderFlow OrderFlow(_OrderFlowEnums.Calculation _oFmethod, _OrderFlowEnums.Representation _oFtakeTextFrom, _OrderFlowEnums.Style _oFStyle, bool _bands, bool _exausthion)
		{
			return indicator.OrderFlow(Input, _oFmethod, _oFtakeTextFrom, _oFStyle, _bands, _exausthion);
		}

		public Indicators.trader_algoritmico.Volume.PSC PSC(bool psc, bool vel_igual, double mecha, int donde_vol, bool _volumeInsideBody)
		{
			return indicator.PSC(Input, psc, vel_igual, mecha, donde_vol, _volumeInsideBody);
		}

		public Indicators.trader_algoritmico.Volume.TapeReconstructor TapeReconstructor(bool aggregateTrades, Brush colorForCircle)
		{
			return indicator.TapeReconstructor(Input, aggregateTrades, colorForCircle);
		}

		public Indicators.trader_algoritmico.Volume.TradeDetection TradeDetection(__VolumeFilterProperties.Formula _formula, long _minVolumeFilter, bool _fillGeometry)
		{
			return indicator.TradeDetection(Input, _formula, _minVolumeFilter, _fillGeometry);
		}

		public Indicators.trader_algoritmico.Volume.VolumePro VolumePro(_MarketAnalyzerEnums.Calculation _marketAnalyzerCalculation, int _period)
		{
			return indicator.VolumePro(Input, _marketAnalyzerCalculation, _period);
		}

		public Indicators.trader_algoritmico.Volume.VolumeProfileChart VolumeProfileChart()
		{
			return indicator.VolumeProfileChart(Input);
		}

		public Indicators.trader_algoritmico.Volume.VolumeProfilePro VolumeProfilePro(NinjaTrader.NinjaScript.Indicators.trader_algoritmico.traderAlgoritmicoAddon.VolumeAnalysis.PeriodMode _periodMode, int _period, bool _showPOC, bool _showPOI, bool _realtimeHeuristic, float _pOCOpacity, float _pOIOpacity, float _selectionOpacity, float _eraseOpacity, float _textOpacity, SimpleFont _textFont, bool _showText, float _minFontWidth, float _minFontHeight)
		{
			return indicator.VolumeProfilePro(Input, _periodMode, _period, _showPOC, _showPOI, _realtimeHeuristic, _pOCOpacity, _pOIOpacity, _selectionOpacity, _eraseOpacity, _textOpacity, _textFont, _showText, _minFontWidth, _minFontHeight);
		}

		public Indicators.trader_algoritmico.Volume.VPOC VPOC(DateTime horaInicio)
		{
			return indicator.VPOC(Input, horaInicio);
		}

		public Indicators.trader_algoritmico.Volume.VWAP VWAP(DateTime horaInicio)
		{
			return indicator.VWAP(Input, horaInicio);
		}


		
		public Indicators.trader_algoritmico.Price.BilliardBands BilliardBands(ISeries<double> input , int numeroBandas)
		{
			return indicator.BilliardBands(input, numeroBandas);
		}

		public Indicators.trader_algoritmico.Price.DynamicSupportResistance DynamicSupportResistance(ISeries<double> input )
		{
			return indicator.DynamicSupportResistance(input);
		}

		public Indicators.trader_algoritmico.Price.Esperanzag Esperanzag(ISeries<double> input , string indicatorName, bool showIndicatorName, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Price.SwingStyle swingType, double swingSize, int dtbStrength, bool useCloseValues, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Price.SwingLengthStyle swingLengthType, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Price.SwingDurationStyle swingDurationType, bool showSwingPrice, bool showSwingLabel, bool showSwingPercent, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Price.SwingTimeStyle swingTimeType, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Price.SwingVolumeStyle swingVolumeType, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Price.VisualizationStyle visualizationType, NinjaTrader.Gui.Tools.SimpleFont textFont, int textOffsetLength, int textOffsetVolume, int textOffsetPrice, int textOffsetLabel, int textOffsetTime, int textOffsetPercent, DashStyleHelper linesStyle, int linesWidth, bool ignoreInsideBars, bool useBreakouts)
		{
			return indicator.Esperanzag(input, indicatorName, showIndicatorName, swingType, swingSize, dtbStrength, useCloseValues, swingLengthType, swingDurationType, showSwingPrice, showSwingLabel, showSwingPercent, swingTimeType, swingVolumeType, visualizationType, textFont, textOffsetLength, textOffsetVolume, textOffsetPrice, textOffsetLabel, textOffsetTime, textOffsetPercent, linesStyle, linesWidth, ignoreInsideBars, useBreakouts);
		}

		public Indicators.trader_algoritmico.Price.LiquidityLevels LiquidityLevels(ISeries<double> input , bool activateLL, bool deleteLine, bool activateFVG, bool useFVGDataSeries, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Price.FVGPeriodTypes fVGBarsPeriodType, int fVGSeriesPeriod, int maxBars, bool useATR, int aTRPeriod, double impulseFactor, double minimumFVGSize, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Price.FVGFillType fillType, bool hideFilledGaps, bool displayCE, int activeAreaOpacity, int filledAreaOpacity, bool drawLabel)
		{
			return indicator.LiquidityLevels(input, activateLL, deleteLine, activateFVG, useFVGDataSeries, fVGBarsPeriodType, fVGSeriesPeriod, maxBars, useATR, aTRPeriod, impulseFactor, minimumFVGSize, fillType, hideFilledGaps, displayCE, activeAreaOpacity, filledAreaOpacity, drawLabel);
		}

		public Indicators.trader_algoritmico.Price.MaxFO MaxFO(ISeries<double> input , DateTime startTime, DateTime endTime)
		{
			return indicator.MaxFO(input, startTime, endTime);
		}

		public Indicators.trader_algoritmico.Price.PowerTrend PowerTrend(ISeries<double> input )
		{
			return indicator.PowerTrend(input);
		}

		public Indicators.trader_algoritmico.Price.PriceActionTrail PriceActionTrail(ISeries<double> input )
		{
			return indicator.PriceActionTrail(input);
		}

		public Indicators.trader_algoritmico.Price.TimePivots TimePivots(ISeries<double> input , bool showWeeklyPivots, bool showMonthlyPivot, bool showOpen, bool showPivot)
		{
			return indicator.TimePivots(input, showWeeklyPivots, showMonthlyPivot, showOpen, showPivot);
		}

		public Indicators.trader_algoritmico.Price.TrendFilter TrendFilter(ISeries<double> input , int eMA1, int eMA2, int eMA3, bool filtro_vpoc)
		{
			return indicator.TrendFilter(input, eMA1, eMA2, eMA3, filtro_vpoc);
		}

		public Indicators.trader_algoritmico.Price.WhereTo WhereTo(ISeries<double> input , string whereToXX1, string whereToXX2, string whereToXX3)
		{
			return indicator.WhereTo(input, whereToXX1, whereToXX2, whereToXX3);
		}

		public Indicators.trader_algoritmico.Utilities.DrawAlert DrawAlert(ISeries<double> input )
		{
			return indicator.DrawAlert(input);
		}

		public Indicators.trader_algoritmico.Utilities.Info Info(ISeries<double> input , int letraSize, Brush letraColor, bool mostrarSpread, bool mostrarNombreCuentaActual, bool mostrarTR, bool mostrarTickSize, bool showPnl, Brush defaultTextColor, Brush inProfitColor, Brush inLossColor, Brush activeOrderColor, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Utilities.Info.textPosition basisTextLocation, bool showNetPriceChange, Cbi.PerformanceUnit unit, NinjaTrader.NinjaScript.Indicators.trader_algoritmico.Utilities.Info.textPosition location)
		{
			return indicator.Info(input, letraSize, letraColor, mostrarSpread, mostrarNombreCuentaActual, mostrarTR, mostrarTickSize, showPnl, defaultTextColor, inProfitColor, inLossColor, activeOrderColor, basisTextLocation, showNetPriceChange, unit, location);
		}

		public Indicators.trader_algoritmico.Utilities.JoiaRenkoPrice JoiaRenkoPrice(ISeries<double> input )
		{
			return indicator.JoiaRenkoPrice(input);
		}

		public Indicators.trader_algoritmico.Utilities.OpeningMarker OpeningMarker(ISeries<double> input , DateTime lineTime, Brush lineColor, DashStyleHelper lineDashStyle, int lineThickness, int barToLineOffsetInTicks)
		{
			return indicator.OpeningMarker(input, lineTime, lineColor, lineDashStyle, lineThickness, barToLineOffsetInTicks);
		}

		public Indicators.trader_algoritmico.Utilities.TickElectrifier TickElectrifier(ISeries<double> input , int frecuenciaActualizacion)
		{
			return indicator.TickElectrifier(input, frecuenciaActualizacion);
		}

		public Indicators.trader_algoritmico.Utilities.TradeManager TradeManager(ISeries<double> input , string selectedAccountName, double _maxDailyProfit, double _maxDailyLoss, int contracts_quantity, bool _usePercentageInsteadOfContracts, double _percentageOfBalanceForTrade, bool _useAtm, bool _tradingDrawnLevel, int usePredSL, int usePredTP, bool _set_BE, int _be_ticks_offset, bool _set_Trailing_Stop, int _tr_start, int _tr_offset, bool _setChangeTSafterProfit, double _changeTSafterProfit, bool _allowEnterOnlyIfVPOCinFavor, bool _allowEnterOnlyIfVWAPinFavor, bool _allowEnterOnlyIfEMA20inFavor, bool _allowEnterOnlyIfBtinFavor, bool _setExitOnBigTrade, bool _setExitOnVPOC, bool _setExitOnVSC, bool _setExitOnClimax)
		{
			return indicator.TradeManager(input, selectedAccountName, _maxDailyProfit, _maxDailyLoss, contracts_quantity, _usePercentageInsteadOfContracts, _percentageOfBalanceForTrade, _useAtm, _tradingDrawnLevel, usePredSL, usePredTP, _set_BE, _be_ticks_offset, _set_Trailing_Stop, _tr_start, _tr_offset, _setChangeTSafterProfit, _changeTSafterProfit, _allowEnterOnlyIfVPOCinFavor, _allowEnterOnlyIfVWAPinFavor, _allowEnterOnlyIfEMA20inFavor, _allowEnterOnlyIfBtinFavor, _setExitOnBigTrade, _setExitOnVPOC, _setExitOnVSC, _setExitOnClimax);
		}

		public Indicators.trader_algoritmico.Volume.ATA ATA(ISeries<double> input , int filter_percentile, Brush colorbt, Brush colorbighand, Brush colorclimax)
		{
			return indicator.ATA(input, filter_percentile, colorbt, colorbighand, colorclimax);
		}

		public Indicators.trader_algoritmico.Volume.Bands Bands(ISeries<double> input , int apilao, int filtro, double filtro2_ratio, int barrasEnFuturo, bool clustersDe1tick)
		{
			return indicator.Bands(input, apilao, filtro, filtro2_ratio, barrasEnFuturo, clustersDe1tick);
		}

		public Indicators.trader_algoritmico.Volume.CandlePOC CandlePOC(ISeries<double> input )
		{
			return indicator.CandlePOC(input);
		}

		public Indicators.trader_algoritmico.Volume.DeltaDivergence DeltaDivergence(ISeries<double> input , Brush barColorDown, Brush barColorUp, Brush shadowColor, int shadowWidth, bool _setAlert, int minSize)
		{
			return indicator.DeltaDivergence(input, barColorDown, barColorUp, shadowColor, shadowWidth, _setAlert, minSize);
		}

		public Indicators.trader_algoritmico.Volume.HeatMap_level2 HeatMap_level2(ISeries<double> input , string _sessionSaveFilePath, bool _saveSession, _HeatMapEnums.LadderRange _ladderRange, _HeatMapEnums.MarketOrdersCalculation _marketOrdersCalculation, _HeatMapEnums.MarketBarsCalculation _marketBarsCalculation, long _aggresiveMarketOrdersFilter, long _filterBigPendingOrders, float _filterPendingOrdersPer, _HeatMapEnums.MarketCummulativeCalculation _marketCummulativeCalculation)
		{
			return indicator.HeatMap_level2(input, _sessionSaveFilePath, _saveSession, _ladderRange, _marketOrdersCalculation, _marketBarsCalculation, _aggresiveMarketOrdersFilter, _filterBigPendingOrders, _filterPendingOrdersPer, _marketCummulativeCalculation);
		}

		public Indicators.trader_algoritmico.Volume.JonReversionPoint JonReversionPoint(ISeries<double> input , Brush barColorDown, Brush barColorUp, Brush shadowColor, int shadowWidth, bool cumulativeDelta, int minSize, bool showDivs)
		{
			return indicator.JonReversionPoint(input, barColorDown, barColorUp, shadowColor, shadowWidth, cumulativeDelta, minSize, showDivs);
		}

		public Indicators.trader_algoritmico.Volume.OrderFlow OrderFlow(ISeries<double> input , _OrderFlowEnums.Calculation _oFmethod, _OrderFlowEnums.Representation _oFtakeTextFrom, _OrderFlowEnums.Style _oFStyle, bool _bands, bool _exausthion)
		{
			return indicator.OrderFlow(input, _oFmethod, _oFtakeTextFrom, _oFStyle, _bands, _exausthion);
		}

		public Indicators.trader_algoritmico.Volume.PSC PSC(ISeries<double> input , bool psc, bool vel_igual, double mecha, int donde_vol, bool _volumeInsideBody)
		{
			return indicator.PSC(input, psc, vel_igual, mecha, donde_vol, _volumeInsideBody);
		}

		public Indicators.trader_algoritmico.Volume.TapeReconstructor TapeReconstructor(ISeries<double> input , bool aggregateTrades, Brush colorForCircle)
		{
			return indicator.TapeReconstructor(input, aggregateTrades, colorForCircle);
		}

		public Indicators.trader_algoritmico.Volume.TradeDetection TradeDetection(ISeries<double> input , __VolumeFilterProperties.Formula _formula, long _minVolumeFilter, bool _fillGeometry)
		{
			return indicator.TradeDetection(input, _formula, _minVolumeFilter, _fillGeometry);
		}

		public Indicators.trader_algoritmico.Volume.VolumePro VolumePro(ISeries<double> input , _MarketAnalyzerEnums.Calculation _marketAnalyzerCalculation, int _period)
		{
			return indicator.VolumePro(input, _marketAnalyzerCalculation, _period);
		}

		public Indicators.trader_algoritmico.Volume.VolumeProfileChart VolumeProfileChart(ISeries<double> input )
		{
			return indicator.VolumeProfileChart(input);
		}

		public Indicators.trader_algoritmico.Volume.VolumeProfilePro VolumeProfilePro(ISeries<double> input , NinjaTrader.NinjaScript.Indicators.trader_algoritmico.traderAlgoritmicoAddon.VolumeAnalysis.PeriodMode _periodMode, int _period, bool _showPOC, bool _showPOI, bool _realtimeHeuristic, float _pOCOpacity, float _pOIOpacity, float _selectionOpacity, float _eraseOpacity, float _textOpacity, SimpleFont _textFont, bool _showText, float _minFontWidth, float _minFontHeight)
		{
			return indicator.VolumeProfilePro(input, _periodMode, _period, _showPOC, _showPOI, _realtimeHeuristic, _pOCOpacity, _pOIOpacity, _selectionOpacity, _eraseOpacity, _textOpacity, _textFont, _showText, _minFontWidth, _minFontHeight);
		}

		public Indicators.trader_algoritmico.Volume.VPOC VPOC(ISeries<double> input , DateTime horaInicio)
		{
			return indicator.VPOC(input, horaInicio);
		}

		public Indicators.trader_algoritmico.Volume.VWAP VWAP(ISeries<double> input , DateTime horaInicio)
		{
			return indicator.VWAP(input, horaInicio);
		}

	}
}

#endregion
